using System;

class Complex
{
    private readonly int x;
    private readonly int y;

    // c'tors
    public Complex () : this (0, 0)
    {
    }

    public Complex (int x, int y)
    {
        this.x = x;
        this.y = y;
    }

    // class methods
    public static Complex Add (Complex a, Complex b)
    {
        return new Complex (a.x + b.x, a.y + b.y);
    }

    public static Complex Sub (Complex a, Complex b)
    {
        return new Complex (a.x - b.x, a.y - b.y);
    }

    public static Complex Mul (Complex a, Complex b)
    {
        return new Complex (a.x * b.x - a.y * b.y, a.x * b.y + a.y * b.x);
    }
    
    // instance methods
    public Complex Add (Complex a)
    {
        return Complex.Add (this, a);
    }

    public Complex Sub (Complex a)
    {
        return Complex.Sub (this, a);
    }

    public Complex Mul (Complex a)
    {
        return Complex.Mul (this, a);
    }

    public Complex Conjugate ()
    {
        return new Complex (this.x, -this.y);
    }

    public double Abs ()
    {
        return Math.Sqrt (this.x * this.x + this.y * this.y);
    }

    public void Print ()
    {
        Console.Write ("[{0},{1}]", this.x, this.y);
    }
}
