#define VARIANTE_01

// #define VARIANTE_01
/*
 *   = Konstruktoren:
 *   = Methode ToString ergnzt (Vererbung Voraussetzung)
 *       public IntegerSet (int capacity);
 *       public IntegerSet (int[] elements);
 * 
 *   = Basismethoden (Insert, Remove, Contains, Print, Count, IsEmpty)
 */
 
// #define VARIANTE_02
/*
 *   = Attribute ergnzt
 *   = Operatoren ergnzt
 */
 
// #define VARIANTE_03
/*
 *   = Methode ToString ergnzt (Vererbung Voraussetzung)
 *   = Klasse EvenIntegerSet ergnzt
 */

// #define VARIANTE_04
/*
 *   = (Standard)Enumerator ergnzt
 */

using System;
using System.Collections;

#if VARIANTE_01
class IntegerSet
{
    private int[] elements;
    private int count;

    // c'tors
    public IntegerSet () : this (16)
    {
    }

    public IntegerSet (int capacity)
    {
        // allocate array
        this.elements = new int[capacity];
        this.count = 0;

        // initialize array
        for (int i = 0; i < elements.Length; i ++)
            elements[i] = -1;
    }

    public IntegerSet (int[] elements) : this (elements.Length)
    {
        // fill array
        for (int i = 0; i < this.elements.Length; i ++)
            this.Insert (elements[i]);
    }

    // public methods
    public bool Insert (int n)
    {
        // check parameter
        if (n < 0)
            return false;

        // element already exists
        if (this.Contains (n))
            return false;

        // search empty slot
        for (int i = 0; i < this.elements.Length; i ++)
        {
            if (this.elements[i] == -1) {
                this.elements[i] = n;
                this.count ++;
                return true;
            }
        }

        // current array is full, allocate a new one
        int[] tmp = new int[2 * this.elements.Length];

        // copy old array into new one
        for (int i = 0; i < this.elements.Length; i ++)
            tmp[i] = this.elements[i];
            
        // initialize second half of array
        for (int i = this.elements.Length; i < tmp.Length; i ++)
            tmp[i] = -1;

        // insert value
        tmp[this.elements.Length] = n;
        this.count ++;

        // adjust array reference
        this.elements = tmp;

        return true;        
    }

    public bool Remove (int n)
    {
        for (int i = 0; i < this.elements.Length; i ++)
            if (this.elements[i] == n)
            {
                this.elements[i] = -1;
                this.count --;
                return true;
            }

        return false;
    }

    public bool Contains (int n)
    {
        for (int i = 0; i < this.elements.Length; i ++)
            if (this.elements[i] == n)
                return true;

        return false;
    }

    public int Count ()
    {
        return this.count;
    }

    public bool IsEmpty ()
    {
        return this.count == 0;
    }

    public void Print ()
    {
        Console.Write ("[");
        int commas = 0;
        for (int i = 0; i < this.elements.Length; i ++)
        {
            if (this.elements[i] != -1)
            {
                Console.Write (this.elements[i]);
                commas ++;
                if (commas < this.count)
                    Console.Write (", ");
            }
        }
        Console.WriteLine ("]");
    }
}

class Demo
{
    public static void Main ()
    {
        IntegerSet s1 = new IntegerSet ();
        s1.Insert (10);
        s1.Insert (11);
        s1.Insert (12);
        s1.Insert (13);
        s1.Insert (14);
        s1.Insert (15);
        s1.Remove (13);
        s1.Print ();
        
        Console.WriteLine ("Count: {0}", s1.Count ());
        Console.WriteLine ("IsEmpty: {0}", s1.IsEmpty ());
        Console.WriteLine ("Contains (12): {0}", s1.Contains (12));
        Console.WriteLine ("Contains (22): {0}", s1.Contains (22));

        int[] elements = { -3, -2, -1, 0, 1, 2, 3 };
        IntegerSet s2 = new IntegerSet (elements);
        s2.Print ();
    }
}
#endif

#if VARIANTE_02
class IntegerSet
{
    private int[] elements;
    private int count;

    // c'tors
    public IntegerSet () : this (16)
    {
    }

    public IntegerSet (int capacity)
    {
        // allocate array
        this.elements = new int[capacity];
        this.count = 0;

        // initialize array
        for (int i = 0; i < elements.Length; i ++)
            elements[i] = -1;
    }

    public IntegerSet (int[] elements) : this (elements.Length)
    {
        // fill array
        for (int i = 0; i < this.elements.Length; i ++)
            this.Insert (elements[i]);
    }

    // public methods
    public bool Insert (int n)
    {
        // check parameter
        if (n < 0)
            return false;

        // element already exists
        if (this.Contains (n))
            return false;

        // search empty slot
        for (int i = 0; i < this.elements.Length; i ++)
        {
            if (this.elements[i] == -1) 
            {
                this.elements[i] = n;
                this.count ++;
                return true;
            }
        }

        // current array is full, allocate a new one
        int[] tmp = new int[2 * this.elements.Length];

        // copy old array into new one
        for (int i = 0; i < this.elements.Length; i ++)
            tmp[i] = this.elements[i];
            
        // initialize second half of array
        for (int i = this.elements.Length; i < tmp.Length; i ++)
            tmp[i] = -1;

        // insert value
        tmp[this.elements.Length] = n;
        this.count ++;

        // adjust array reference
        this.elements = tmp;

        return true;        
    }

    public bool Remove (int n)
    {
        for (int i = 0; i < this.elements.Length; i ++)
            if (this.elements[i] == n)
            {
                this.elements[i] = -1;
                this.count --;
                return true;
            }

        return false;
    }

    public bool Contains (int n)
    {
        for (int i = 0; i < this.elements.Length; i ++)
            if (this.elements[i] == n)
                return true;

        return false;
    }

    public void Print ()
    {
        Console.Write ("[");
        for (int i = 0, n = 0; i < this.elements.Length; i ++)
        {
            if (this.elements[i] != -1)
            {
                Console.Write (this.elements[i]);
                n ++;
                if (n < this.count)
                    Console.Write (", ");
            }
        }
        Console.WriteLine ("]");
    }

    // public properties
    public int Count
    {
        get
        {
            return this.count;
        }
    }

    public bool IsEmpty
    {
        get
        {
            return this.count == 0;
        }
    }

    // public operators
    public static IntegerSet operator+ (IntegerSet s1, IntegerSet s2)
    {
        IntegerSet tmp = new IntegerSet (s1.elements);

        for (int i = 0; i < s2.elements.Length; i ++)
        {
            int n = s2.elements[i];
            if (n == -1)
                continue;

            tmp.Insert (n);
        }

        return tmp;
    }

    public static IntegerSet operator^ (IntegerSet s1, IntegerSet s2)
    {
        IntegerSet tmp = new IntegerSet ();

        for (int i = 0; i < s1.elements.Length; i ++)
        {
            int n = s1.elements[i];
            if (n == -1)
                continue;

            if (s2.Contains (n))
                tmp.Insert (n);
        }

        return tmp;
    }

    public static IntegerSet operator- (IntegerSet s1, IntegerSet s2)
    {
        IntegerSet tmp = new IntegerSet ();

        for (int i = 0; i < s1.elements.Length; i ++)
        {
            int n = s1.elements[i];
            if (n == -1)
                continue;

            if (! s2.Contains (n))
                tmp.Insert (n);
        }

        return tmp;
    }

    public static bool operator<= (IntegerSet s1, IntegerSet s2)
    {
        // compare both sets element per element
        for (int i = 0; i < s1.elements.Length; i ++)
        {
            int n = s1.elements[i];
            if (n == -1)
                continue;

            if (! s2.Contains (n))
                return false;

        }

        return true;
    }

    public static bool operator>= (IntegerSet s1, IntegerSet s2)
    {
        return s2 <= s1;
    }

    public static bool operator== (IntegerSet s1, IntegerSet s2)
    {
        return (s1 <= s2) && (s2 <= s1);
    }

    public static bool operator!= (IntegerSet s1, IntegerSet s2)
    {
        return ! (s1 == s2);
    }
}

class Demo
{
    public static void Main ()
    {
        int[] elements1 = { 10, 11, 12, 13, 14, 15 };
        IntegerSet s1 = new IntegerSet (elements1);
        s1.Print ();

        int[] elements2 = { 14, 15, 16, 17, 18, 19 };
        IntegerSet s2 = new IntegerSet (elements2);
        s2.Print ();

        IntegerSet s3 = s1 + s2;
        s3.Print ();

        IntegerSet s4 = s1 ^ s2;
        s4.Print ();

        IntegerSet s5 = s1 - s2;
        s5.Print ();

        bool b = s1 <= s2;
        Console.WriteLine ("s1 <= s2: {0}", b);
        b = s2 <= s3;
        Console.WriteLine ("s2 <= s3: {0}", b);

        IntegerSet s6 = new IntegerSet (elements1);
        b = s1 == s6;
        Console.WriteLine ("s1 == s6: {0}", b);
    }
}
#endif

#if VARIANTE_03
class IntegerSet
{
    private int[] elements;
    private int count;

    // c'tors
    public IntegerSet () : this (16)
    {
    }

    public IntegerSet (int capacity)
    {
        // allocate array
        this.elements = new int[capacity];
        this.count = 0;

        // initialize array
        for (int i = 0; i < elements.Length; i ++)
            elements[i] = -1;
    }

    public IntegerSet (int[] elements) : this (elements.Length)
    {
        // fill array
        for (int i = 0; i < this.elements.Length; i ++)
            this.Insert (elements[i]);
    }

    // public methods
    public virtual bool Insert (int n)
    {
        // check parameter
        if (n < 0)
            return false;

        // element already exists
        if (this.Contains (n))
            return false;

        // search empty slot
        for (int i = 0; i < this.elements.Length; i ++)
        {
            if (this.elements[i] == -1) 
            {
                this.elements[i] = n;
                this.count ++;
                return true;
            }
        }

        // current array is full, allocate a new one
        int[] tmp = new int[2 * this.elements.Length];

        // copy old array into new one
        for (int i = 0; i < this.elements.Length; i ++)
            tmp[i] = this.elements[i];
            
        // initialize second half of array
        for (int i = this.elements.Length; i < tmp.Length; i ++)
            tmp[i] = -1;

        // insert value
        tmp[this.elements.Length] = n;
        this.count ++;

        // adjust array reference
        this.elements = tmp;

        return true;        
    }

    public bool Remove (int n)
    {
        for (int i = 0; i < this.elements.Length; i ++)
            if (this.elements[i] == n)
            {
                this.elements[i] = -1;
                this.count --;
                return true;
            }

        return false;
    }

    public bool Contains (int n)
    {
        for (int i = 0; i < this.elements.Length; i ++)
            if (this.elements[i] == n)
                return true;

        return false;
    }

    // public properties
    public int Count
    {
        get
        {
            return this.count;
        }
    }

    public bool IsEmpty
    {
        get
        {
            return this.count == 0;
        }
    }

    // overrides
    public override String ToString ()
    {
        String s = "[";
        for (int i = 0, n = 0; i < this.elements.Length; i ++)
        {
            if (this.elements[i] != -1)
            {
                s = String.Concat (s, this.elements[i]);
                n ++;
                if (n < this.count)
                    s = String.Concat (s, ", ");
            }
        }
        s = String.Concat (s, "]");

        return s;
    }
}

// inheritance
class EvenIntegerSet : IntegerSet 
{
    // c'tors
    public EvenIntegerSet (int[] elements) : base (elements.Length)
    {
        for (int i = 0; i < elements.Length; i ++)
            this.Insert (elements[i]);
    }

    public EvenIntegerSet (int capacity) : base (capacity)
    {
    }

    // public methods
    public override bool Insert (int n)
    {
        // check parameter
        if (n % 2 != 0)
            return false;

        // user base class implementation
        return base.Insert (n);
    }
}

class Demo
{
    public static void Main ()
    {
        int[] elements1 = { 10, 11, 12, 13, 14, 15 };
        IntegerSet s1 = new IntegerSet (elements1);
        Console.WriteLine (s1);

        int[] elements2 = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
        EvenIntegerSet s2 = new EvenIntegerSet (elements2);
        Console.WriteLine (s2);

        EvenIntegerSet s3 = new EvenIntegerSet (10);
        s3.Insert (0);
        s3.Insert (2);
        s3.Insert (4);
        Console.WriteLine (s3);
    }
}

#endif

#if VARIANTE_04
class IntegerSet : IEnumerable, IEnumerator
{
    private int[] elements;
    private int count;

    // index used for enumeration
    private int position;

    // c'tors
    public IntegerSet () : this (16)
    {
    }

    public IntegerSet (int capacity)
    {
        // allocate array
        this.elements = new int[capacity];
        this.count = 0;
        this.position = -1;

        // initialize array
        for (int i = 0; i < elements.Length; i ++)
            elements[i] = -1;
    }

    public IntegerSet (int[] elements) : this (elements.Length)
    {
        // fill array
        for (int i = 0; i < this.elements.Length; i ++)
            this.Insert (elements[i]);
    }

    // public methods
    public virtual bool Insert (int n)
    {
        // check parameter
        if (n < 0)
            return false;

        // element already exists
        if (this.Contains (n))
            return false;

        // search empty slot
        for (int i = 0; i < this.elements.Length; i ++)
        {
            if (this.elements[i] == -1) 
            {
                this.elements[i] = n;
                this.count ++;
                return true;
            }
        }

        // current array is full, allocate a new one
        int[] tmp = new int[2 * this.elements.Length];

        // copy old array into new one
        for (int i = 0; i < this.elements.Length; i ++)
            tmp[i] = this.elements[i];
            
        // initialize second half of array
        for (int i = this.elements.Length; i < tmp.Length; i ++)
            tmp[i] = -1;

        // insert value
        tmp[this.elements.Length] = n;
        this.count ++;

        // adjust array reference
        this.elements = tmp;

        return true;        
    }

    public bool Remove (int n)
    {
        for (int i = 0; i < this.elements.Length; i ++)
            if (this.elements[i] == n)
            {
                this.elements[i] = -1;
                this.count --;
                return true;
            }

        return false;
    }

    public bool Contains (int n)
    {
        for (int i = 0; i < this.elements.Length; i ++)
            if (this.elements[i] == n)
                return true;

        return false;
    }

    // public properties
    public int Count
    {
        get
        {
            return this.count;
        }
    }

    public bool IsEmpty
    {
        get
        {
            return this.count == 0;
        }
    }

    // overrides
    public override String ToString ()
    {
        String s = "[";
        for (int i = 0, n = 0; i < this.elements.Length; i ++)
        {
            if (this.elements[i] != -1)
            {
                s = String.Concat (s, this.elements[i]);
                n ++;
                if (n < this.count)
                    s = String.Concat (s, ", ");
            }
        }
        s = String.Concat (s, "]");

        return s;
    }

    // implementation of interface 'IEnumerable'
    public IEnumerator GetEnumerator ()
    {
        return (IEnumerator) this;
    }
    
    // implementation of interface 'IEnumerator'
    public Object Current
    {
        get
        {
            return this.elements[this.position];
        }
    }

    public bool MoveNext ()
    {
        // advance index to next element
        this.position ++;
        while (this.position < this.elements.Length)
        {
            if (this.elements[this.position] != -1)
                return true;

            this.position ++;
        }

        // prepare next enumeration
        this.position = -1;

        return false;
    }

    public void Reset ()
    {
        this.position = -1;
    }
}

class Demo
{
    public static void Main ()
    {
        IntegerSet s = new IntegerSet ();
        s.Insert (1);
        s.Insert (2);
        s.Insert (3);
        s.Insert (4);
        s.Insert (5);

        if (s is IEnumerable)
        {
            IEnumerator ienum = (IEnumerator) s;

            // first traversal
            while (ienum.MoveNext ())
            {
                int n = (int) ienum.Current;
                Console.WriteLine ("got {0}", n);
            }

            // testing second run of enumerator
            while (ienum.MoveNext ())
            {
                int k = (int) ienum.Current;
                Console.WriteLine ("got {0}", k);
            }
        }
    }
}
#endif
