using System;

class Sieve 
{
    private bool[] primes;

    public Sieve (int num) 
    {
        this.Init (num);
    }

    public void Init (int num)
    {
        // create an array that specifies whether each number is prime or not
        this.primes = new bool[num];

        // assume that all numbers are prime numbers
        for (int i = 2; i < this.primes.Length; i++)
            this.primes[i] = true;

        // 0 and 1 are not prime numbers
        this.primes[0] = false;
        this.primes[1] = false;
    }

    public void Calc ()
    {
        int max = (int) Math.Sqrt (this.primes.Length);
        for (int i = 2; i < max; i ++) 
        {
            if (this.primes[i]) 
            {
                // mark all multiples of i
                for (int j = 2 * i; j < this.primes.Length; j += i) 
                {
                    this.primes[j] = false;
                }
            }
        }
    }

    public void Print ()
    {
        int newLine = 0;

        for (int i = 2; i < this.primes.Length; i ++) 
        {
            if (this.primes[i] != false) 
            {
                Console.Write ("{0,5}", i);

                newLine ++;
                if (newLine % 8 == 0)
                    Console.WriteLine ();
            }
        }
        Console.WriteLine ();
    }
}

class Demo
{
    public static void Main () 
    {
        Sieve s = new Sieve (100);
        s.Calc ();
        s.Print ();

        s.Init (1111);
        s.Calc ();
        s.Print ();
    }
}