using System;

abstract class Shape
{
    public abstract void Draw ();
}

class Window : Shape
{
    protected int top;
    protected int left;

    public Window (int top, int left)
    {
        this.top = top;
        this.left = left;
    }

    public override void Draw ()
    {
        Console.WriteLine ("Window: {0}, {1}", top, left);
    }
}

class Label : Window
{
    public Label (int top, int left) : base (top, left)
    {
    }

    public override void Draw ()
    {
        Console.WriteLine ("Label: {0}, {1}", top, left);
    }
}

class Button : Window
{
    public Button (int top, int left) : base (top, left)
    {
    }

    public override void Draw ()
    {
        Console.WriteLine ("Button: {0}, {1}", top, left);
    }
}

class Polymorphismus
{
    public static void Main ()
    {
        Shape[] shapes = new Shape[3];

        // create a simple window ...
        Window w = new Window (10, 20);

        // ... and a Label
        Label lb = new Label (20, 40);

        // ... and a Button
        Button b = new Button (40, 80);

        // fill array with custom controls
        shapes[0] = w;
        shapes[1] = lb;
        shapes[2] = b;

        for (int i = 0; i < shapes.Length; i ++)
        {
            shapes[i].Draw ();
        }
    }
}
