#define VARIANT_01
// #define VARIANT_02
// #define VARIANT_03
// #define VARIANT_04
// #define VARIANT_05

#if VARIANT_01

#define LOG_DIVISOR
#undef LOG_DIVISOR

using System;
using System.Diagnostics;

class Primes
{
    public static bool IsPrime (int num) 
    {
        for (int i = 2; i < num/2; i++)
        {
            LogDivisor (i);
            if (num == i * (num/i))
                return false;
        }

        return true;
    }

    [Conditional ("LOG_DIVISOR")]
    private static void LogDivisor (int num)
    {
        Console.WriteLine ("current divisor: {0}", num);
    }
}

class Demo
{
    public static void Main1 ()
    {
        Console.WriteLine ("calling Primes.IsPrime ...");
        int candidate = 17;
        bool b = Primes.IsPrime (candidate);
        String result =
            String.Format ("{0} is {1} prime.", candidate, b ? "" : " not");
        Console.WriteLine (result);
    }

    public static void Main ()
    {
        Console.WriteLine ("calling Primes.IsPrime ...");
        int candidate = 17;
        if (Primes.IsPrime (candidate))
            Console.WriteLine ("{0} is prime.", candidate);
    }
}

#endif

#if VARIANT_02

using System;

[Obsolete ("Use class B instead")]
class A
{
    public void AnyMethod () {}
}

class B
{
    public void AnyMethod () {}
}

class Test
{
    public static void Main () 
    {
        A a = new A ();  // Compiler generates warning
        a.AnyMethod ();
    }
}

#endif

#if VARIANT_03

using System;

[Obsolete ("Use class B instead", true)]
class A
{
    public void AnyMethod () {}
}

#endif

#if VARIANT_04

#define CONDITION1

using System;
using System.Diagnostics;

class MultiuseAttributeDemo
{
    [Conditional ("CONDITION1")]
    [Conditional ("CONDITION2")]
    public static void Method ()
    {
        Console.WriteLine ("CONDITION1 or CONDITION2 is specified");
    }
}

class Demo
{
    public static void Main ()
    {
        MultiuseAttributeDemo.Method ();
    }
}

#endif

#if VARIANT_05

using System;
using System.Runtime.InteropServices;

class Win32
{
    [  DllImport ("user32.dll",    /* name of DLL */
       EntryPoint = "MessageBox")  /* name of DLL entry point */
    ]
    public static extern int MessageBoxWrapper (
        int hWnd,
        String text, 
        String caption,
        uint type
    );
}

class Test 
{
    public static void Main () 
    {
        Win32.MessageBoxWrapper (0, "Hello World ...", "Platform Invoke Sample", 1);
    }
}

#endif