#define VARIANT_01
// #define VARIANT_02
// #define VARIANT_02a
// #define VARIANT_03
// #define VARIANT_04
// #define VARIANT_05
// #define VARIANT_06
// #define VARIANT_07
// #define VARIANT_08a
// #define VARIANT_08b
// #define VARIANT_08c
// #define VARIANT_09
// #define VARIANT_10
// #define VARIANT_11

using System;

#if VARIANT_01
class Rectangle
{
    public int x;
    public int y;
    public int width;
    public int height;

    public Rectangle () : this (1, 1, 10, 10)
    {
    }
    
    public Rectangle (int x, int y, int width, int height)
    {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
    }

    public void MoveTo (int x, int y)
    {
        this.x = x;
        this.y = y;
    }
}

class ColoredRectangle
{
    public int x;
    public int y;
    public int width;
    public int height;
    public int color;

    public ColoredRectangle () : this (1, 1, 10, 10, 100)
    {
    }

    public ColoredRectangle (int x, int y, int width, int height, int color)
    {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.color = color;
    }

    public void MoveTo (int x, int y)
    {
        this.x = x;
        this.y = y;
    }
}

class Demo
{
    public static void Main ()
    {
        Rectangle r = new Rectangle (1, 1, 10, 10);
        r.MoveTo (10, 11);

        ColoredRectangle cr = new ColoredRectangle (1, 1, 10, 10, 999);
        cr.MoveTo (10, 11);
    }
}
#endif

#if VARIANT_02
class Rectangle
{
    public int x;
    public int y;
    public int width;
    public int height;

    public Rectangle () : this (1, 1, 10, 10)
    {
    }
    
    public Rectangle (int x, int y, int width, int height)
    {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
    }

    public void MoveTo (int x, int y)
    {
        this.x = x;
        this.y = y;
    }
}

class ColoredRectangle : Rectangle
{
    public int color;

    public ColoredRectangle () : this (1, 1, 10, 10, 100)
    {
    }

    public ColoredRectangle (int x, int y, int width, int height, int color)
    {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.color = color;
    }
}

class Demo
{
public static void Main ()
{
    Rectangle r = new Rectangle (1, 1, 10, 10);
    r.MoveTo (10, 11);

    ColoredRectangle cr = new ColoredRectangle (1, 1, 10, 10, 999);
    cr.MoveTo (10, 11);
}
}
#endif

#if VARIANT_02a

class Point
{
    public int x;
    public int y;
}

class Line
{
    public Point start;
    public Point end;
}

#endif

#if VARIANT_03
class Base
{
//    public int x = 1;

    public void Method ()
    {
        Console.WriteLine ("Base Method");
    }
}

class Derived : Base
{
//    public new int x = 2;
//
//    public int Sum ()
//    {
//        return x + base.x;
//    }

    public new void Method ()
    {
        Console.WriteLine ("Derived Method");
        base.Method ();
    }
}

class Demo
{
    public static void Main ()
    {
        Derived d = new Derived ();
//        Console.WriteLine (d.x);
//        Console.WriteLine (d.Sum ());

        d.Method ();
    }
}

#endif

#if VARIANT_04
class Rectangle
{
    protected int x;
    protected int y;
    protected int width;
    protected int height;

    public Rectangle (int x, int y, int width, int height)
    {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
    }

    public void MoveTo (int x, int y)
    {
        this.x = x;
        this.y = y;
    }

    public void Print ()
    {
        Console.Write ("[x={0}, y={1}, width={2}, height={3}]",
            this.x, this.y, this.width, this.height);
    }
}


class ColoredRectangle : Rectangle
{
    private int color;

    public ColoredRectangle (int x, int y, int width, int height, int color)
    {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.color = color;
    }

    public void Print ()
    {
        Console.Write ("[x={0}, y={1}, width={2}, height={3}]",
            this.x, this.y, this.width, this.height);
        Console.Write ("[color={0}]", this.color);
    }
}
#endif

#if VARIANT_05
class Rectangle
{
    public int x;
    public int y;
    public int width;
    public int height;

    public Rectangle () : this (1, 1, 10, 10)
    {
    }
    
    public Rectangle (int x, int y, int width, int height)
    {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
    }

    public void MoveTo (int x, int y)
    {
        this.x = x;
        this.y = y;
    }

    public void Print ()
    {
        Console.Write ("[{0},{1},{2},{3}]",
            this.x, this.y, this.width, this.height);
    }
}

class ColoredRectangle : Rectangle
{
    public int color;

    public ColoredRectangle () : this (1, 1, 10, 10, 100)
    {
    }

    public ColoredRectangle (int x, int y, int width, int height, int color)
    {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.color = color;
    }

    public new void Print ()
    {
//        Console.Write ("[{0},{1},{2},{3}]",
//            this.x, this.y, this.width, this.height);
        base.Print ();
        Console.Write ("[{0}]", this.color);
    }
}

class Demo
{
    public static void Main ()
    {
        Rectangle r = new Rectangle (1, 1, 10, 10);
        r.Print ();
        Console.WriteLine ();

        ColoredRectangle cr = new ColoredRectangle (1, 1, 10, 10, 999);
        cr.Print ();
    }
}
#endif

#if VARIANT_06
class A
{
    public int x;
    public int x;
}

class B : A
{
    public new int x = 2;
}

class Demo
{
    public static void Main ()
    {
//        B b = new B ();
//        Console.WriteLine (b.x);
    }
}

#endif

#if VARIANT_07
class Rectangle
{
    public int x;
    public int y;
    public int width;
    public int height;

    public Rectangle () : this (1, 1, 10, 10)
    {
    }
    
    public Rectangle (int x, int y, int width, int height)
    {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
    }

    public void MoveTo (int x, int y)
    {
        this.x = x;
        this.y = y;
    }

    public void Print ()
    {
        Console.Write ("[{0},{1},{2},{3}]",
            this.x, this.y, this.width, this.height);
    }
}

class ColoredRectangle : Rectangle
{
    public int color;

    public ColoredRectangle () : this (1, 1, 10, 10, 100)
    {
    }

    public ColoredRectangle (int x, int y, int width, int height, int color)
    : base (x, y, width, height)
    {
        this.color = color;
    }

    public new void Print ()
    {
        base.Print ();
        Console.Write ("[{0}]", this.color);
    }
}

class Demo
{
    public static void Main ()
    {
        Rectangle r = new Rectangle (1, 1, 10, 10);
        r.Print ();
        Console.WriteLine ();

        ColoredRectangle cr = new ColoredRectangle (1, 1, 10, 10, 999);
        cr.Print ();
    }
}
#endif

#if VARIANT_08a
class A
{
  public virtual void AnyMethod ()
  {
  }
}

class Demo
{
  public static void Main ()
  {
     A a = new A ();
  }
}

#endif

#if VARIANT_08b
class A
{
  public virtual void AnyMethod ()
  {
  }
}

class B : A
{
  public override void AnyMethod ()
  {
  }
}

class Demo
{
    public static void Main ()
    {
        B b = new B ();
    }
}

#endif

#if VARIANT_08c
class A
{
    public virtual void AnyMethod ()
    {
    }
}

class B : A
{
    public override void AnyMethod ()
    {
        // ...
        base.AnyMethod ();
        // ...
    }
}

class Demo
{
    public static void Main ()
    {
        B b = new B ();
    }
}

#endif

#if VARIANT_09
class Base
{
    protected int value;
}

class Derived : Base
{
    public int GetValue ()
    {
        return this.value;
    }
}

class Outside
{
    public int Fails (Base b)
    {
        Console.WriteLine (b.value);
    }
}

class Demo
{
    public static void Main ()
    {
    }
}

#endif

#if VARIANT_10

class Rectangle
{
    public void Print ()
    {
        Console.WriteLine ("Rectangle");
    }
}

class ColoredRectangle : Rectangle
{
    public int color = 0;

    public new void Print ()
    {
        Console.WriteLine ("ColoredRectangle");
    }
}

class Demo
{
    public static void Main ()
    {
        Demo01 ();
    }

    public static void Demo01 ()
    {
        ColoredRectangle cr = new ColoredRectangle ();
        Rectangle r;
        r = cr;
    }

    public static void Demo02 ()
    {
        Rectangle r = new Rectangle ();
        ColoredRectangle cr;
        //cr = r;
    }

    public static void Demo03 ()
    {
        Rectangle r = new Rectangle ();
        ColoredRectangle cr;
        cr = (ColoredRectangle) r;
    }

    public static void Demo04 ()
    {
        ColoredRectangle cr = new ColoredRectangle ();
        Rectangle r;
        r = cr;
        r.Print ();
    }
}

#endif

#if VARIANT_11
// same as VARIANT_07 except keyword virtual
class Rectangle
{
    public int x;
    public int y;
    public int width;
    public int height;

    public Rectangle ()
    {
        this.x = 1;
        this.y = 1;
        this.width = 10;
        this.height = 10;
    }
    
    public virtual void Print ()
    {
        Console.Write ("[{0},{1},{2},{3}]",
            this.x, this.y, this.width, this.height);
    }
}

class ColoredRectangle : Rectangle
{
    public int color;

    public ColoredRectangle ()
    {
        this.color = 100;
    }

    public override void Print ()
    {
        base.Print ();
        Console.Write ("[{0}]", this.color);
    }
}

class Demo
{
    public static void Main ()
    {
        ColoredRectangle cr = new ColoredRectangle ();
        Rectangle r;
        r = cr;
        r.Print ();
    }
}
#endif

