using System;

class Window
{
    protected int top;
    protected int left;

    public Window (int top, int left)
    {
        this.top = top;
        this.left = left;
    }

    public virtual void Draw ()
    {
        Console.WriteLine ("Window: {0}, {1}", top, left);
    }
}

class Label : Window
{
    public Label (int top, int left) : base (top, left)
    {
    }

    public override void Draw ()
    {
        Console.WriteLine ("Label: {0}, {1}", top, left);
    }
}

class Button : Window
{
    public Button (int top, int left) : base (top, left)
    {
    }

    public override void Draw ()
    {
        Console.WriteLine ("Button: {0}, {1}", top, left);
    }
}

class Polymorphismus
{
    public static void Main ()
    {
        Window[] windows = new Window[3];

        Window w = new Window (10, 20);  // create a simple window ...
        Label lb = new Label (20, 40);   // ... and a Label
        Button b = new Button (40, 80);  // ... and a Button

        // fill array with custom controls
        windows[0] = w;
        windows[1] = lb;
        windows[2] = b;

        for (int i = 0; i < windows.Length; i ++)
        {
            windows[i].Draw ();
        }
    }
}
