#define VARIANTE_01
// #define VARIANTE_02
// #define VARIANTE_03

using System;

#if VARIANTE_01
class Rectangle
{
    public Point location;  // reference type
    public int width;       // value type
    public int height;      // value type
}

class Point
{
    public int x;
    public int y;
}


class Demo
{
    public static void Main ()
    {
        Rectangle r = new Rectangle ();
        r.width = 10; 
        r.height = 20;
        r.location = new Point ();

        Rectangle rc = r;
        rc.location.x = 2;
    }
}
#endif

#if VARIANTE_02
class Rectangle : ICloneable
{
    public Rectangle (int x, int y, int width, int height)
    {
        this.location = new Point (x, y);
        this.width = width;
        this.height = height;
    }

    public Point location;  // reference type
    public int width;       // value type
    public int height;      // value type

    // return a new object that is a copy of the current instance
    public Object Clone ()
    {
        return new Rectangle (
            this.location.x,
            this.location.y,
            this.width,
            this.height
        );
    }

    public override String ToString ()
    {
        return String.Format ("[{0},{1},{2},{3}]", 
            this.location.x, this.location.y, this.width,this.height);
    }
}

class Point
{
    public Point (int x, int y)
    {
        this.x = x;
        this.y = y;
    }

    public int x;
    public int y;
}


class Demo
{
    public static void Main ()
    {
        Rectangle r1 = new Rectangle (1, 1, 10, 20);
        Rectangle r2 = (Rectangle) r1.Clone ();

        Console.WriteLine ("r1: " + r1);
        Console.WriteLine ("r2: " + r2);

        r2.location.x = 2;
        Console.WriteLine ("r1: " + r1);
        Console.WriteLine ("r2: " + r2);
    }
}
#endif

#if VARIANTE_03
class Rectangle : ICloneable
{
    public Rectangle (int x, int y, int width, int height)
    {
        this.location = new Point (x, y);
        this.width = width;
        this.height = height;
    }

    public Point location;  // reference type
    public int width;       // value type
    public int height;      // value type

    public Object Clone ()
    {
        // create a shallow copy of the current object
        return this.MemberwiseClone ();
    }

    public override String ToString ()
    {
        return String.Format ("[{0},{1},{2},{3}]", 
            this.location.x, this.location.y, this.width,this.height);
    }
}

class Point
{
    public Point (int x, int y)
    {
        this.x = x;
        this.y = y;
    }

    public int x;
    public int y;
}


class Demo
{
    public static void Main ()
    {
        Rectangle r1 = new Rectangle (1, 1, 10, 20);
        Rectangle r2 = (Rectangle) r1.Clone ();

        Console.WriteLine ("r1: " + r1);
        Console.WriteLine ("r2: " + r2);

        r2.location.x = 2;
        Console.WriteLine ("r1: " + r1);
        Console.WriteLine ("r2: " + r2);
    }
}
#endif