using System;
using System.Collections;

class DevilsSequence : IEnumerable, IEnumerator
{
    private int start;
    private int current;
    private int next;

    // c'tor
    public DevilsSequence (int start)
    {
        this.start = start;
        this.current = start;
        this.next = start;
    }

    // property
    public int Start
    {
        get
        {
            return this.start;
        }
    }

    // implementation of interface 'IEnumerable'
    public IEnumerator GetEnumerator ()
    {
        return (IEnumerator) this;
    }

    // implementation of interface 'IEnumerator'
    public Object Current
    {
        get
        {
            return this.current;
        }
    }

    public bool MoveNext ()
    {
        bool tmp = this.current != 1 ? true : false;
        this.current = this.next;
        this.next = (this.current % 2 == 1) ?
            (3 * this.current + 1) / 2 :
            (this.current / 2);
        return tmp;
    }

    public void Reset ()
    {
        this.current = this.start;
        this.next = this.start;
    }
}

class Demo
{
    public static void Main ()
    {
        Demo01 ();
        // Demo02 ();
        // Demo03 ();
    }

    public static void Demo01 ()
    {
        DevilsSequence sequence = new DevilsSequence (7);
        if (sequence is IEnumerable)
        {
            IEnumerator ienum = ((IEnumerable) sequence).GetEnumerator ();
            while (ienum.MoveNext ())
            {
                int number = (int) ienum.Current;
                Console.WriteLine ("Next:  {0}", number);
            }
        }
    }

    public static void Demo02 ()
    {
        DevilsSequence sequence = new DevilsSequence (7);
        if (sequence is IEnumerable)
        {
            IEnumerator ienum = ((IEnumerable) sequence).GetEnumerator ();
            for (int i = 0; i < 5; i ++)
            {
                if (! ienum.MoveNext ())
                    break;

                int number = (int) ienum.Current;
                Console.WriteLine ("Next:  {0}", number);
            }

            Console.WriteLine ("Resetting enumeration ...");
            ienum.Reset ();
            while (ienum.MoveNext ())
            {
                int number = (int) ienum.Current;
                Console.WriteLine ("Next:  {0}", number);
            }
        }
    }

    public static void Demo03 ()
    {
        DevilsSequence sequence = new DevilsSequence (7);
        foreach (int number in sequence)
            Console.WriteLine ("Next:  {0}", number);
    }
}