using System;
using System.Collections;

class MagicNumber6174 : IEnumerable, IEnumerator
{
    private int start;
    private int current;

    // default c'tor
    public MagicNumber6174 ()
    {
        this.start = 1;
        this.current = 1;
    }

    // set first number of sequence
    public int Start
    {
        set
        {
            if (value % 1111 == 0)
            {
                this.start = 1;
                this.current = 1;
                return;
            }

            this.start = value;
            this.current = value;
        }

        get
        {
            return this.start;
        }
    }

    // implementation of interface 'IEnumerable'
    public IEnumerator GetEnumerator ()
    {
        return (IEnumerator) this;
    }

    // implementation of interface 'IEnumerator'
    public void Reset ()
    {
        this.current = this.start;
    }

    public Object Current
    {
        get
        {
            return this.current;
        }
    }

    public bool MoveNext ()
    {
        // end of sequence reached
        if (this.current == 6174)
            return false;

        // copy digits of current number into temporary array
        int[] digits = new int[4];
        int tmp = this.current;
        for (int i = 0; i < 4; i ++)
        {
            digits[i] = tmp % 10;
            tmp = tmp / 10;
        }

        // sort digits array
        Array.Sort (digits);

        // calculate minimum and maxiumum number
        int max = digits[0] + 10*digits[1] + 100*digits[2] + 1000*digits[3];
        int min = digits[3] + 10*digits[2] + 100*digits[1] + 1000*digits[0];

        // next sequence number
        this.current = max - min;
        return true;
    }

    public void CalculateLongestSequence (out int number, out int length)
    {
        number = 0;
        length = 0;

        for (int k = 1; k < 10000; k ++)
        {
            if (k % 1111 == 0)
                continue;

            this.Start = k;
            int len = 0;
            while (this.MoveNext ())
                len ++;

            if (len > length)
            {
                length = len;
                number = k;
            }
        }    
    }
}
