using System;
using System.Collections;
using System.Collections.Specialized;

class Order
{
    private int orderID;
    private int[] productIDs;

    public Order (int orderID, params int[] productIDs)
    {
        this.orderID = orderID;
        this.productIDs = new int[productIDs.Length];
        for (int i = 0; i < productIDs.Length; i ++)
            this.productIDs[i] = productIDs[i];
    }

    public int ID
    {
        get
        {
            return this.orderID;
        }
    }

    public void Print ()
    {
        Console.Write ("Order ID: {0}, ", this.orderID);
        Console.Write ("Products: ");
        for (int i = 0; i < productIDs.Length; i ++)
        {
            if (i > 0)
                Console.Write (", ");
            Console.Write ("{0}", productIDs[i]);
        }
        Console.WriteLine ();
    }
}

class CollectionDemo
{
    public static void Demo01 ()
    {
        StringCollection col = new StringCollection ();
        for (int i = 0; i < 10; i ++)
            col.Add ((i * 10).ToString ());

        for (int i = 0; i < col.Count; i ++)
        {
            String s = col[i];
            Console.WriteLine (s);
        }

        StringEnumerator ienum = col.GetEnumerator ();
        while (ienum.MoveNext ())
        {
            String s = ienum.Current;
            Console.WriteLine (s);
        }
    }
    
    public static void Demo02 ()
    {
        Hashtable tab = new Hashtable ();

        Order order1 = new Order (0, 324689, 423793, 328692);
        Order order2 = new Order (3, 675512, 552618);
        Order order3 = new Order (2, 426634, 576736, 1253432);
        tab.Add (order1.ID, order1);
        tab.Add (order2.ID, order2);
        tab.Add (order3.ID, order3);

        IEnumerator ienum = tab.GetEnumerator ();
        while (ienum.MoveNext ())
        {
            DictionaryEntry entry = (DictionaryEntry) ienum.Current;
            Order order = (Order) entry.Value;
            order.Print ();
        }

        int key = 2;
        if (tab.Contains (key))
        {
            Order o = (Order) tab[key];
            // ...
        }
    }
}

class Demo
{
    public static void Main ()
    {
        CollectionDemo.Demo02 ();
    }
}