#define VARIANTE_01
// #define VARIANTE_02

using System;

class Demo
{
    public static void  Main ()
    {
#if VARIANTE_01
        Demo01 ();
#endif
#if VARIANTE_02
        Demo02 ();
#endif
    }

#if VARIANTE_01
    public static void Demo01 ()
    {
        /** testing c'tors */
        Console.WriteLine ("default c'tor:");
        Matrix m1 = new Matrix ();
        m1.Print ();
        Console.WriteLine ();

        Console.WriteLine ("user defined c'tor (3, 2):");
        Matrix m2 = new Matrix (3, 2);
        m2.Print ();
        Console.WriteLine ();

        Console.WriteLine ("user defined c'tor (int[]):");
        int[,] values =
        {
            { 1, 2, 3 },
            { 4, 5, 6 }
        };
        Matrix m3 = new Matrix (values);
        m3.Print ();
        Console.WriteLine ();

        /** testing elementary matrix operations */
        Console.WriteLine ("matrix m1:");
        int[,] values1 =
        {
            { 1, 2, 3 },
            { 4, 5, 6 }
        };
        m1 = new Matrix (values1);
        m1.Print ();
        Console.WriteLine ();

        Console.WriteLine ("matrix m2:");
        int[,] values2 =
        {
            { 1, 2, 3 },
            { 4, 5, 6 }
        };
        m2 = new Matrix (values2);
        m2.Print ();
        Console.WriteLine ();

        Console.WriteLine ("m1 Add m2:");
        m3 = m1.Add (m2);
        m3.Print ();
        Console.WriteLine ();

        Console.WriteLine ("m1 Sub m2");
        m3 = m1.Sub (m2);
        m3.Print ();
        Console.WriteLine ();

        Console.WriteLine ("matrix m2:");
        int[,] values3 =
        {
            { 1, 2, 3 },
            { 4, 5, 6 },
            { 7, 8, 9 }
        };
        m2 = new Matrix (values3);
        m2.Print ();
        Console.WriteLine ();

        Console.WriteLine ("m1 Mul m2:");
        m3 = m1.Mul (m2);
        m3.Print ();
        Console.WriteLine ();

        Console.WriteLine ("copy of matrix m1:");
        m2 = (Matrix) m1.Clone ();
        m2.Print ();
        Console.WriteLine ();

        Console.WriteLine ("compare m1 with m2: {0}", m1.Equals (m2));
        Console.WriteLine ("modifying m1: m1[0, 0]");
        m1[0, 0] = 17;
        Console.WriteLine ("compare m1 with m2: {0}", m1.Equals (m2));

        /** testing operators */
        Console.WriteLine ("matrix m1:");
        int[,] values4 =
        {
            { 1, 2, 3 },
            { 4, 5, 6 }
        };
        m1 = new Matrix (values4);
        m1.Print ();
        Console.WriteLine ();

        Console.WriteLine ("matrix m2:");
        int[,] values5 =
        {
            { 1, 2, 3 },
            { 4, 5, 6 }
        };
        m2 = new Matrix (values5);
        m2.Print ();
        Console.WriteLine ();

        Console.WriteLine ("m1 + m2:");
        m3 = m1 + m2;
        m3.Print ();
        Console.WriteLine ();

        Console.WriteLine ("m2 - m1:");
        m3 = m1 - m2;
        m3.Print ();
        Console.WriteLine ();

        Console.WriteLine ("matrix m2:");
        int[,] values6 =
        {
            { 1, 2, 3 },
            { 4, 5, 6 },
            { 7, 8, 9 }
        };
        m2 = new Matrix (values6);
        m2.Print ();
        Console.WriteLine ();

        Console.WriteLine ("m1 * m2:");
        m3 = m1 * m2;
        m3.Print ();
        Console.WriteLine ();

        /** testing indexer */
        Console.WriteLine ("m1");
        m1.Print ();
        Console.WriteLine ();
        m1[1, 2] = 17;
        Console.WriteLine ("m1[1, 2] = 17");
        m1.Print ();
        Console.WriteLine ();
        int n = m1[1, 2];
        Console.WriteLine ("int n = m1[1, 2];");
        Console.WriteLine ("n = {0}", n);
        Console.WriteLine ();

        /** testing miscellaneous matrix operations */
        Matrix id = Matrix.Identity (4, 6);
        Console.WriteLine ("identity matrix (4, 6):");
        id.Print ();
        Console.WriteLine ();

        int[,] values7 =
        {
            { 2,  9,  9,  4 },
            { 2, -3, 12,  8 },
            { 4,  8,  3, -5 },
            { 1,  2,  6,  4 }
        };
        m1 = new Matrix (values7);
        m1.Print ();
        int det = m1.Determinant ();
        Console.WriteLine ("determinant of m1: {0}", det);
        Console.WriteLine ();

        Console.WriteLine ("transpose of m1:");
        m1 = m1.Transpose ();
        m1.Print ();
        Console.WriteLine ();

        Console.WriteLine ("submatrix (2, 3) of m1:");
        m1 = m1.SubMatrix (2, 3);
        m1.Print ();
        Console.WriteLine ();
    }
#endif

#if VARIANTE_02
    public static void Demo02 ()
    {
        try
        {
            /** testing invalid index error */
            Matrix m1 = new Matrix (2, 2);
            int x = m1[2, 0];
        }
        catch (MatrixException me)
        {
            Console.WriteLine ("{0}: Kind: {1}, Wrong Index: {2}",
                me.Message, me.Kind, me.ErrorValue);
        }            

        try
        {
            /** testing invalid dimension error */
            Matrix m1 = new Matrix (2, 2);
            Matrix m2 = new Matrix (2, 3);
            Matrix m3 = m1.Add (m2);
        }
        catch (MatrixException me)
        {
            Console.WriteLine ("{0}: Kind: {1}, Wrong Dimension: {2}",
                me.Message, me.Kind, me.ErrorValue);
        }    
    }
#endif
}
