using System;

class Demo
{
    public static void Main ()
    {
        Console.WriteLine ("Testing class 'Polynom';");
        Console.WriteLine ("");

        // zero polynom
        Polynom p = new Polynom ();
        Console.WriteLine ("Null-Polynom: {0}", p);
        Console.WriteLine ();

        // polynom of degree 3
        double[] values1 = { 2, -4, 0, 3 };
        Polynom p1 = new Polynom (values1);
        Console.WriteLine ("Polynom 1: {0}", p1.ToString ());
        Console.WriteLine ("Degree:    {0}", p1.Rank);

        // polynom of degree 2
        double[] values2 = { 3, 3, 5 };
        Polynom p2 = new Polynom (values2);
        Console.WriteLine ("Polynom 2: {0}", p2.ToString ());
        Console.WriteLine ("Degree:    {0}", p2.Rank);
        Console.WriteLine ();

        // polynom addition
        Polynom p3 = p1 + p2;
        Console.WriteLine ("p1 + p2: {0}", p3);

        // polynom multiplication
        p3 = p1 * p2;
        Console.WriteLine ("p1 * p2: {0}", p3);
        Console.WriteLine ();

        // coefficients
        for (int i = 0; i <= p3.Rank; i ++)
            Console.WriteLine ("Coefficient at {0}: {1}", i, p3.Coefficients[i]);
        Console.WriteLine ();

        // value of p2 at 0.0, 1.0 and 2.0
        double y = p2[0.0];
        Console.WriteLine ("p2(0.0) = {0}", y);
        y = p2[1.0];
        Console.WriteLine ("p2(1.0) = {0}", y);
        y = p2[2.0];
        Console.WriteLine ("p2(2.0) = {0}", y);
        Console.WriteLine ();

        // value of p3 at 0.0, 1.0 and 2.0
        y = p3[0.0];
        Console.WriteLine ("p3(0.0) = {0}", y);
        y = p3[1.0];
        Console.WriteLine ("p3(1.0) = {0}", y);
        y = p3[2.0];
        Console.WriteLine ("p3(2.0) = {0}", y);
        Console.WriteLine ();

        // testing 'ICloneable'
        Polynom p4 = (Polynom) p3.Clone ();
        Console.WriteLine ("p3.Clone: {0}", p4);
        Console.WriteLine ();

        // testing some operators
        bool b = p3 == p4;
        Console.WriteLine ("p3 == p4: {0}", b);
        b = p3 != p4;
        Console.WriteLine ("p3 != p4: {0}", b);

        b = p1 < p2;
        Console.WriteLine ("p1 < p2:  {0}", b);
        b = p1 <= p2;
        Console.WriteLine ("p1 <= p2: {0}", b);
        b = p1 > p2;
        Console.WriteLine ("p1 > p2:  {0}", b);
        b = p1 >= p2;
        Console.WriteLine ("p1 >= p2: {0}", b);
    }
}


