using System;

class Demo
{
    public static void Main ()
    {
        // testing addition
        BigInteger a = new BigInteger ("12121212121212121212121212121");
        BigInteger b = new BigInteger ("43434343434343434343434343434");
        BigInteger c = a + b;
        Console.WriteLine ("{0} + {1} = {2}", a, b, c);

        a = new BigInteger ("1");
        b = new BigInteger ("999999999999999999999999999");
        Console.WriteLine ("{0} + {1} = {2}", a, b, a + b);

        // addition example from script
        a = new BigInteger (28345);
        b = new BigInteger (7567);
        c = new BigInteger (89123);
        Console.WriteLine ("{0} + {1} + {2} = {3}", a, b, c, a + b + c);

        // testing multiplication
        a = new BigInteger ("1212121212");
        b = new BigInteger ("4343434343");
        Console.WriteLine ("{0} * {1} = {2}", a, b, a * b);

        // multiplication example from script
        a = new BigInteger ("973018");
        b = new BigInteger ("9758");
        Console.WriteLine ("{0} * {1} = {2}", a, b, a * b);

        // testing method 'Power'
        BigInteger n = new BigInteger ("2");
        for (int i = 0; i < 128; i ++)
        {
            BigInteger m = n.Power (i);
            Console.WriteLine ("2 to the power of {0}: {1}", i, m);
        }

        // testing c'tor "BigInteger (long)"
        a = new BigInteger (Int64.MaxValue);
        Console.WriteLine ("Int64.MaxValue: {0}", a);

        // testing equality and inequality operator
        a = new BigInteger ("123456789123456789");
        b = new BigInteger ("123456789123456789");
        Console.WriteLine ("{0} == {1}: {2}", a, b, a == b);
        a = a + 1;  // note: conversion operator is used
        Console.WriteLine ("{0} == {1}: {2}", a, b, a == b);
        Console.WriteLine ("{0} != {1}: {2}", a, b, a != b);

        // testing overloaded variants of equality and inequality operator
        a = new BigInteger ("123456789");
        if (a == "123456789")
            Console.WriteLine ("{0} equals {1}", a, "123456789");
        a ++;
        if (a != "123456789")
            Console.WriteLine ("{0} is not equal {1}", a, "123456789");

        // testing comparison operators
        a = new BigInteger ("123456788");
        b = new BigInteger ("123456789");
        Console.WriteLine ("{0} <  {1}: {2}", a, b, a < b);
        Console.WriteLine ("{0} >  {1}: {2}", a, b, a > b);
        Console.WriteLine ("{0} <= {1}: {2}", a, b, a <= b);
        Console.WriteLine ("{0} >= {1}: {2}", a, b, a >= b);

        // testing interface 'IComparable'
        Console.WriteLine ("{0} CompareTo {1}: {2}", a, b, a.CompareTo (b));
        Console.WriteLine ("{0} CompareTo {1}: {2}", b, a, b.CompareTo (a));
        b = a;
        Console.WriteLine ("{0} CompareTo {1}: {2}", b, a, b.CompareTo (a));

        // testing 'IComparable' interface
        BigInteger[] bigInts = new BigInteger[3];
        bigInts[0] = new BigInteger ("123456789012345");
        bigInts[1] = new BigInteger ("1234567890");
        bigInts[2] = new BigInteger ("12345");
        for (int i = 0; i < bigInts.Length; i ++)
            Console.WriteLine (bigInts[i]);
        Array.Sort (bigInts);
        for (int i = 0; i < bigInts.Length; i ++)
            Console.WriteLine (bigInts[i]);
    }
}

