// #define VARIANT_01
#define VARIANT_02

using System;
using System.Text;

#if VARIANT_01
class FormattingDemo
{
	public static void Main()
	{
        // introduction
        Console.WriteLine ("{0},{1},{2}", 10, 11, 12);
        Console.WriteLine ("{{{0}}}", 1);
        Console.WriteLine ("{1},{0},{1}", 10, 11, 12);
        //Console.WriteLine ("{0},{},{2}", 10, 11);

        // standard numeric format strings
        Console.WriteLine ("01: {0:C}", 123456.789);
        Console.WriteLine ("02: {0,10:D}", 12345);
        Console.WriteLine ("03: {0,-10:D}", 12345);
        Console.WriteLine ("04: {0:D10}", 12345);
        Console.WriteLine ("05: {0:E}", 123.456);
        Console.WriteLine ("06: {0:F}", 123.456);
        Console.WriteLine ("07: {0:F3}", 123.456);
        Console.WriteLine ("08: {0:G}", 123.456);
        Console.WriteLine ("09: {0:N}", 123456789);
        Console.WriteLine ("10: {0:N0}", 123456789);
        Console.WriteLine ("11: {0:P}", 0.12);
        Console.WriteLine ("12: {0:P}", 0.1234);
        Console.WriteLine ("13: {0:P0}", 0.12);
        Console.WriteLine ("14: {0:R}", 12345.6789);
        Console.WriteLine ("15: {0:X}", 65535);
        Console.WriteLine ("16: {0,8:X}", 65535);
        Console.WriteLine ("17: {0:X8}", 65535);

        // user defined numeric format strings
        Console.WriteLine ("01: {0:0}", 123);
        Console.WriteLine ("02: {0:00000}", 123);
        Console.WriteLine ("03: {0:#}", 123);
        Console.WriteLine ("04: {0:#####}", 123);
        Console.WriteLine ("05: {0:###.#}", 1.234);
        Console.WriteLine ("06: {0:##.##}", 1.234);
        Console.WriteLine ("07: {0:#.###}", 1.234);
        Console.WriteLine ("08: {0:###%}", 1.234);
        Console.WriteLine ("09: {0:###.#%}", 1.234);
        Console.WriteLine ("10: {0:###E0}", 10000);
        Console.WriteLine ("11: {0:###E0}", -10000);
        Console.WriteLine ("12: {0:##E+0}", 10000);
        Console.WriteLine ("13: {0:###E+0}", 10000);
        Console.WriteLine ("14: {0:####E+0}", 10000);
        Console.WriteLine ("15: {0:#####E+0}", 10000);
        Console.Write ("16: {0:'1.' Result':' 0'.'\n}", 123);
        Console.WriteLine ("17: {0:\">>>\" 0 '<<<'}", 456);
    }
}
#endif

#if VARIANT_02
class Complex : IFormattable
{
    private int x;
    private int y;

    public Complex (int x, int y)
    {
        this.x = x;
        this.y = y;
    }

    public override String ToString ()
    {
        return String.Format ("[{0},{1}]", x, y);
    }

    public String ToString (String format, IFormatProvider provider)
    {
        if (format == null)
            return this.ToString ();

        if (format.Equals ("cart"))
            return String.Format ("{0}+i{1}", x, y);
        else if (format.Equals ("vect"))
            return String.Format ("({0},{1})", x, y);
        else
            return this.ToString ();
    }
}

class FormattingDemo
{
    public static void Main()
    {
        Complex c = new Complex (1, 2);
        Console.WriteLine ("c: {0}", c);
        Console.WriteLine ("c: {0:cart}", c);
        Console.WriteLine ("c: {0:vect}", c);

        // demo
        Console.WriteLine ("c: value is {0:cart} rsp. {0:vect}.", c);

        // converted demo
        String tmp = String.Format ("c: value is {0:cart} rsp. {0:vect}.", c);
        Console.WriteLine (tmp);

        // converted demo (2. variant)
//        StringBuilder sb = new StringBuilder ();
//        sb.Append ("c: value is ");
//
//        sb.AppendFormat ("{0:cart}", c);
//
//        sb.Append (" rsp. ");
//
//        sb.AppendFormat ("{0:vect}", c);
//
//        sb.Append (".");
//        String tmp = sb.ToString ();
//        Console.WriteLine (tmp);
    }
}
#endif
