#define VARIANT_01
// #define VARIANT_02
// #define VARIANT_03
// #define VARIANT_04

using System;
using System.Text;

class StringBuilderDemo
{
#if VARIANT_01
	public static void Main ()
	{        StringBuilder sb = new StringBuilder ("Hello World", 12);
        Console.WriteLine ("Length: {0}, Capacity: {1}", sb.Length, sb.Capacity);

        sb.Append ('.');
        Console.WriteLine ("Length: {0}, Capacity: {1}", sb.Length, sb.Capacity);

        sb.Append ('.');
        Console.WriteLine ("Length: {0}, Capacity: {1}", sb.Length, sb.Capacity);
    }
#endif

#if VARIANT_02
	public static void Main ()
	{        StringBuilder sb = new StringBuilder ();
        sb.Append ("Demo: ");
        sb.Append (1);
        sb.Append (" + ");
        sb.Append (2);
        sb.Append ("= 3.");
        Console.WriteLine (sb.ToString ());
    }
#endif

#if VARIANT_03
    public static void Main ()
    {
        StringBuilder sb = new StringBuilder (">>><<<");
        sb.Insert (3, 123);
        Console.WriteLine (sb.ToString ());
    }
#endif

#if VARIANT_04
	public static void Main ()
	{
        int start = Environment.TickCount;
        StringBuilderDemo.Stress01 (100000);
        int end = Environment.TickCount - start;
        Console.WriteLine ("Stress01: [{0} milliseconds]", end);

        start = Environment.TickCount;
        StringBuilderDemo.Stress02 (100000);
        end = Environment.TickCount - start;
        Console.WriteLine ("Stress02: [{0} milliseconds]", end);
    }

    public static void Stress01 (int max)
    {
        String s = null;
        for (int i = 0; i < max; i ++)
        {
            s = "";
            for (int k = 'A'; k < 'Z'; k ++)
                s = s + Convert.ToChar (k);
        }
        Console.WriteLine (s);
    }

    public static void Stress02 (int max)
    {
        StringBuilder sb = new StringBuilder (25);
        for (int i = 0; i < max; i ++)
        {
            sb.Remove (0, sb.Length);
            for (int k = 'A'; k < 'Z'; k ++)
                sb.Append (Convert.ToChar (k));
        }
        Console.WriteLine (sb.ToString ());
    }
#endif
}
