#define VARIANT_01
// #define VARIANT_02
// #define VARIANT_03
// #define VARIANT_04
// #define VARIANT_05
// #define VARIANT_06
// #define VARIANT_07

using System;

enum BoilingPoints
{
    Fahrenheit = 212,
    Celcius = 100
}

enum Colors : int
{
    Red = 0,
    Green = 1,
    Blue = 2
}

[Flags]
enum FileAttributes
{
    Archive     =  0x00000001,  // the file has archive status
    Compressed  =  0x00000002,  // the file is compressed
    Directory   =  0x00000004,  // the file is a directory
    Hidden      =  0x00000008,  // the file is hidden
    ReadOnly    =  0x00000010,  // the file is read-only
    System      =  0x00000020,  // the file is a system file
}

class Demo
{
    public static void Main ()
    {
#if VARIANT_01
        Object o = Colors.Red;
        Console.WriteLine (o.ToString ());

        String s = Colors.Green.ToString ();
        Console.WriteLine (s);

        Console.WriteLine (Colors.Blue);
#endif

#if VARIANT_02
        Type t = typeof (Colors);
        String[] names = Enum.GetNames (t);
        for (int i = 0; i < names.Length; i ++)
            Console.WriteLine ("{0}: {1}", i, names[i]);
#endif

#if VARIANT_03
        Type t = typeof (BoilingPoints);
        int[] values = (int[]) Enum.GetValues (t);
        for (int i = 0; i < values.Length; i ++)
            Console.WriteLine ("{0}: {1}", i, values[i]);
#endif

#if VARIANT_04
    Type t = typeof (BoilingPoints);
    BoilingPoints point = (BoilingPoints) Enum.Parse (t, "Celcius");
    Console.WriteLine (point);
#endif

#if VARIANT_05
    Type t = typeof (BoilingPoints);
    BoilingPoints point = (BoilingPoints) Enum.ToObject (t , 212);
    Console.WriteLine (point);
#endif

#if VARIANT_06
        bool b1 = Enum.IsDefined (typeof(BoilingPoints), 100);
        bool b2 = Enum.IsDefined (typeof(BoilingPoints), 101);
        Console.WriteLine (b1);
        Console.WriteLine (b2);
#endif

#if VARIANT_07
        FileAttributes attr1 = FileAttributes.System | FileAttributes.ReadOnly;

        FileAttributes attr2 = FileAttributes.Archive;
        // ...
        attr2 = attr2 | FileAttributes.Compressed;
        attr2 |= FileAttributes.Compressed;

        FileAttributes attr3 = FileAttributes.System | FileAttributes.ReadOnly;

        if ((attr3 & FileAttributes.ReadOnly) == FileAttributes.ReadOnly)
            Console.WriteLine ("Yes ...");
        // FileAttributes.ReadOnly is present
#endif
    }
}


