using System;

// note: return value of type 'void' necessary
delegate void Operation (double val);

class MathOperations
{
    public static void MultiplyByTwo (double val)
    {
        double res = 2 * val;
        Console.WriteLine ("Multiplying {0} by 2 gives {1}", val, res);
    }

    public static void Square (double val)
    {
        double res = val * val;
        Console.WriteLine ("Squaring {0} gives {1}", val, res);
    }
}

class MulticastDelegateDemo
{
    public static void Main ()
    {
        Example01 ();
        Console.WriteLine ();
        Example02 ();
        Console.WriteLine ();
        Example02a ();
        Console.WriteLine ();
        Example03 ();
    }

    public static void Example01 ()
    {
        Operation multiplyOperation =
            new Operation (MathOperations.MultiplyByTwo);

        Operation squareOperation =
            new Operation (MathOperations.Square);

        Operation operations =
            multiplyOperation + squareOperation;

        operations (3.0);

        operations = operations - squareOperation;

        operations (3.0);
    }

    public static void Example02 ()
    {
        Operation operations =
            new Operation (MathOperations.MultiplyByTwo);

        Operation squareOperation =
            new Operation (MathOperations.Square);

        operations += squareOperation;

        operations (3.0);

        operations -= squareOperation;

        operations (3.0);
    }

    public static void Example02a ()
    {
        Operation operations =
            new Operation (MathOperations.MultiplyByTwo);

        operations += new Operation (MathOperations.Square);

        operations (3.0);

        operations -= new Operation (MathOperations.Square);

        operations (3.0);
    }

    public static void Example03 ()
    {
        Operation multiplyOperation =
            new Operation (MathOperations.MultiplyByTwo);

        Operation squareOperation =
            new Operation (MathOperations.Square);

        Operation operations =
            (Operation) MulticastDelegate.Combine (multiplyOperation, squareOperation);

        operations (3.0);

        operations = (Operation) MulticastDelegate.Remove (operations, squareOperation);

        operations (3.0);
    }
}
