#define NONSTATIC_VARIANT
// #define STATIC_VARIANT
// #define ARRAYS_AND_PARAMETERS

using System;

#if NONSTATIC_VARIANT

using NonstaticCalculator;

class Demo
{
    public static void Main ()
    {
        // create an instance of class 'Calculator'
        Calculator calc = new Calculator ();

        // create an instance of the 'Calculate' delegate
        // using instance method 'Add' of class 'Calculator'       
        Calculate d = new Calculate (calc.Add);

        d (1);
        d (2);
        int result = calc.Total;
        Console.WriteLine ("Total = {0}", result);
    }
}
#endif


#if STATIC_VARIANT

using StaticCalculator;

class Demo
{
    public static void Main ()
    {
        Calculate d = new Calculate (AnotherCalculator.Add);
        int result = d (2, 3);
        Console.WriteLine ("Total = {0}", result);
    }
}
#endif

#if ARRAYS_AND_PARAMETERS
delegate double DoubleOperation (double x);

class MathOperations
{
    public static double MultiplyByTwo (double val)
    {
        return 2 * val;
    }

    public static double Square (double val)
    {
        return val * val;
    }

    public static void DoOperation (DoubleOperation op, double val)
    {
        double result = op (val);
        Console.WriteLine ("val={0}, result={1}", val, result);
    }
}

class Demo
{
    public static void Main ()
    {
        // create two delegate instances
        DoubleOperation firstOperation =
            new DoubleOperation (MathOperations.MultiplyByTwo);

        DoubleOperation secondOperation = 
            new DoubleOperation (MathOperations.Square);

        // create an array of delegates
        DoubleOperation[] operations = {firstOperation, secondOperation};

        // calling delegated method inside array
        operations[0](3.0);

        for (int i = 0; i < operations.Length; i ++)
        {
            Console.WriteLine ("now calling operation {0}", i);
            MathOperations.DoOperation (operations[i], 3.0);
        }
    }
}
#endif
