using System;

class ArithmeticOverflow
{
	public static void Main ()
	{
        Demo01 ();
	}

    public static void Demo01 ()
    {
        int value = Int32.MaxValue; // largest possible value of an int variable
        value ++;
        Console.WriteLine (value);
    }

    public static void Demo02 ()
    {
        unchecked
        {
            int value = Int32.MaxValue; // largest possible value of an int variable
            value ++;
            Console.WriteLine (value);
        }
    }

    public static void Demo03 ()
    {
        checked
        {
            int value = Int32.MaxValue; // largest possible value of an int variable
            value ++;
            Console.WriteLine (value);
        }
    }

    public static void Demo04 ()
    {
        try
        {
            checked
            {
                int value = Int32.MaxValue; // largest possible value of an int variable
                value ++;
                Console.WriteLine (value);
            }        
        }
        catch (OverflowException)
        {
            Console.WriteLine ("Error: An arithmetic operation with" +
                "variable 'value' resulted in an overflow");
        }
    }

    public static void Demo05 ()
    {
        try
        {
            int value = Int32.MaxValue;
            Console.WriteLine (checked (value ++));

        }
        catch (OverflowException)
        {
            Console.WriteLine ("Error: An arithmetic operation with" +
                "variable 'value' resulted in an overflow");
        }
    }
}
