using System;

class IllegalDateException : ApplicationException
{
    private int illegalValue;

    public IllegalDateException () : this ("")
    {
    }

    public IllegalDateException (String message) : base (message)
    {
        this.illegalValue = 0;
    }
    
    public int IllegalValue
    {
        set
        {
            this.illegalValue = value;
        }

        get
        {
            return this.illegalValue;
        }
    }
}

class Date
{
    private int day;
    private int month;
    private int year;

    public Date (int day, int month, int year)
    {
        // very, very simple consistency check
        if (day < 0 || day >= 31)
        {
            IllegalDateException e =
                new IllegalDateException ("Day out of Range");
            e.IllegalValue = day;
            throw e;
        }
        
        if (month < 0 || month >= 12)
        {
            IllegalDateException e =
                new IllegalDateException ("Month out of Range");
            e.IllegalValue = month;
            throw e;
        }
        
        this.day = day;
        this.month = month;
        this.year = year;
    }
}

class Demo
{
    public static void Main ()
    {
        try
        {
            Date d = new Date (1, 99, 2004);
        }
        catch (IllegalDateException e)
        {
            Console.WriteLine ("Problem with Date: {0}: {1}",
                e.Message, e.IllegalValue);
        }
    }
}
