using System;

class ExceptionHandling
{
    public void Demo01 ()
    {
        int[] array = new int[10];

        // access array with correct index
        try
        {
            int val = array[0];
        }
        catch (IndexOutOfRangeException e)
        {
            Console.WriteLine ("Error{0}", e.Message);
        }

        // calculate (erroneous) index
        int i = 20;

        // access array
        try
        {
            int val = array[i];
            Console.WriteLine ("Array at index {0} accessed ...", i);

        }
        catch (IndexOutOfRangeException e)
        {
            Console.WriteLine ("Error{0}", e.Message);
        }    
    }

    public void Demo02 ()
    {
        // generate two random numbers
        Random r = new Random ();
        int x = r.Next (10);
        int y = r.Next (10);

        // create array, 10 elements long
        int[] array = new int[5];

        // consider two risky statements
        try
        {
            Console.WriteLine ("x/y gives {0}", x/y);
            Console.WriteLine ("y is {0}, array[y] is {1}", y, array[y]);
        }
        catch (IndexOutOfRangeException e)
        {
            Console.WriteLine ("Error: {0}", e.Message);
        }
        catch (DivideByZeroException e)
        {
            Console.WriteLine ("Division Problem: {0}", e.Message);
        }
    }

    public void Demo03 ()
    {
        Method01 ();
    }

    public void Method01 ()
    {
        Console.WriteLine ("entering Method01");
        this.Method02 ();
        Console.WriteLine ("leaving Method01");
    }

    public void Method02 ()
    {
        Console.WriteLine ("entering Method02");
        this.Method03 ();
        Console.WriteLine ("leaving Method02");
    }

    public void Method03 ()
    {
        Console.WriteLine ("entering Method03");
        Exception ex = new Exception ();
        throw ex;
        // Console.WriteLine ("leaving Method03");
    }

    public void Demo04 ()
    {
        try
        {
            // statements that may throw exceptions
        }
        catch (IndexOutOfRangeException)
        {
            // handler for Exception01
        }
        catch (NullReferenceException)
        {
            // handler for Exception01
        }
        catch (Exception)
        {
        }
    }

    /***
    public int Demo05 (int x, int y)
    {
        try
        {
            return x / y;
        }
        catch (ArithmeticException)
        {
            Console.WriteLine ("ArithmeticException caught");
        }        
        catch (DivideByZeroException)
        {
            Console.WriteLine ("DivideByZeroException caught");
        }

        return 0;
    }
    ***/

    public int Demo06 (int x, int y)
    {
        try
        {
            x = Int32.MaxValue;
            x = x + 1;
            return x / y;
        }
        catch (DivideByZeroException)
        {
            Console.WriteLine ("DivideByZeroException caught");
        }
        catch (ArithmeticException)
        {
            Console.WriteLine ("ArithmeticException caught");
        }        

        return 0;
    }
}
//
//class Demo
//{
//    public static void Main1 ()
//    {
//        ExceptionHandling eh = new ExceptionHandling ();
//        eh.Demo06 (3, 0);
//    }
//}
