using System;

class SimpleQueue
{
    // internal queue data
    private int[] buf;
    private int head;
    private int tail;
    private int num;

    // c'tor(s)
    public SimpleQueue () : this (10)
    {
    }

    public SimpleQueue (int size)
    {
        this.buf = new int[size];
        this.head = 0;
        this.tail = 0;
        this.num = 0;
    }

    // properties
    public bool IsEmpty
    {
        get
        {
            return (this.num == 0);
        }
    }

    public bool IsFull
    {
        get
        {
            return (this.num == this.buf.Length);
        }
    }

    // methods
    public void Add (int value)
    {
        if (this.IsFull)
            throw new InvalidOperationException ("Queue is full");

        // add item
        this.buf[this.head] = value;
        this.num ++;

        // advance queue index
        this.head ++;
        if (this.head == this.buf.Length)
            this.head = 0;
    }

    public int Remove ()
    {
        if (this.IsEmpty)
            throw new InvalidOperationException ("Queue is empty");

        // remove item
        int tmp = this.buf[this.tail];
        this.num --;

        // advance queue index
        this.tail ++;
        if (this.tail == this.buf.Length)
            this.tail = 0;

        return tmp;
    }
}

class Demo
{
    public static void Main ()
    {
        SimpleQueue q = new SimpleQueue (3);

        Console.WriteLine ("Queue is empty: {0}", q.IsEmpty);

        q.Add (1);
        q.Add (2);
        q.Add (3);

        try
        {
            q.Add (4);
        }
        catch (InvalidOperationException)
        {
            Console.WriteLine ("Add failed");
        }

        Console.WriteLine ("Queue is empty: {0}", q.IsEmpty);

        int n;
        n = q.Remove ();
        Console.WriteLine ("Remove: {0}", n);
        n = q.Remove ();
        Console.WriteLine ("Remove: {0}", n);
        n = q.Remove ();
        Console.WriteLine ("Remove: {0}", n);

        try
        {
            n = q.Remove ();
        }
        catch (InvalidOperationException)
        {
            Console.WriteLine ("Remove failed");
        }
    }
}
