using System;

class SimpleStack
{
    private int[] buf;
    private int top;

    // c'tor(s)
    public SimpleStack () : this (10)
    {
    }

    public SimpleStack (int size)
    {
        this.buf = new int[size];
        this.top = 0;
    }

    // properties
    public bool IsEmpty
    {
        get
        {
            return this.top == 0;
        }
    }

    public bool IsFull
    {
        get
        {
            return this.top == this.buf.Length;
        }
    }
    
    // methods
    public void Push (int value)
    {
        if (this.IsFull)
            throw new InvalidOperationException ("Stack is full");

        // remove item
        this.buf[this.top] = value;
        this.top ++;
    }

    public int Pop () 
    {
        if (this.IsEmpty)
            throw new InvalidOperationException ("Stack is empty");

        // add item
        this.top --;
        return this.buf[this.top];
    }
}

class Demo
{
    public static void Main ()
    {
        SimpleStack s = new SimpleStack (3);

        Console.WriteLine ("Stack is empty: {0}", s.IsEmpty);

        s.Push (1);
        s.Push (2);
        s.Push (3);

        try
        {
            s.Push (4);
        }
        catch (InvalidOperationException)
        {
            Console.WriteLine ("Push failed");
        }

        Console.WriteLine ("Stack is empty: {0}", s.IsEmpty);

        int n;
        n = s.Pop ();
        Console.WriteLine ("Pop: {0}", n);
        n = s.Pop ();
        Console.WriteLine ("Pop: {0}", n);
        n = s.Pop ();
        Console.WriteLine ("Pop: {0}", n);

        try
        {
            n = s.Pop ();
        }
        catch (InvalidOperationException)
        {
            Console.WriteLine ("Pop failed");
        }
    }
}
