using System;
using System.Drawing;
using System.Windows.Forms;
using System.Drawing.Text;

class CentricText : Form
{
    // default c'tor
    public CentricText ()
    {
        // set caption bar text and size of this form
        this.Text = "Centered Text";
        this.BackColor = Color.White;
        this.ClientSize = new Size (400, 80);

        // control must be redrawn when it is resized
        this.ResizeRedraw = true;
    }

    protected override void OnPaint (PaintEventArgs e)
    {
        // set up string
        String s = "C# is beautiful";

        // choose a font
        Font f = new Font (
            "Times New Roman",  // font family
            32                  // size of font object (using points)
        );

        // retrieve font height (in pixel)
        float stringHeight = f.GetHeight ();

        // calculate width of string to draw (in pixel)
        SizeF stringSize = e.Graphics.MeasureString (s, f);

        // calculate upper-left corner of the text to draw
        float x = (this.ClientSize.Width - stringSize.Width) / 2;
        float y = (this.ClientSize.Height - stringHeight) / 2;

        // draw string at the specified position
        PointF pointF = new PointF (x, y);
        e.Graphics.DrawString (
            s,             // string to draw
            f,             // font object
            Brushes.Blue,  // brush object
            pointF         // PointF structure
        );

        // release font object
        f.Dispose ();
    }
}
