#define VERSION_01
// #define VERSION_02
// #define VERSION_03
// #define VERSION_04

using System;
using System.Windows.Forms;
using System.Drawing;

class Demo
{
    public static void Main ()
    {
        MyForm f = new MyForm ();
        Application.Run (f);
    }
}

#if VERSION_01
class MyForm : Form
{
    // default c'tor
    public MyForm ()
    {
        // set caption bar text and size of this form
        this.Text = "Drawing Circles and Ellipses";
        this.BackColor = Color.White;
        this.ClientSize = new Size (343, 120);

        // control must be redrawn when it is resized
        this.ResizeRedraw = true;
    }

    // ellipsis
    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // draw circle (using a standard pen)
        e.Graphics.DrawEllipse (Pens.Black, 10, 10, 100, 100);

        // draw ellipse
        Rectangle r = new Rectangle (130, 10, 200, 100);
        Pen p = new Pen (Color.Blue, 3);
        e.Graphics.DrawEllipse (p, r);
        p.Dispose ();
    }
}
#endif

#if VERSION_02
class MyForm : Form
{
    // default c'tor
    public MyForm ()
    {
        // set caption bar text and size of this form
        this.Text = "Drawing Arcs";
        this.BackColor = Color.White;
        this.ClientSize = new Size (230, 120);

        // control must be redrawn when it is resized
        this.ResizeRedraw = true;
    }

    // ellipsis
    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // draw two arcs
        Pen p = new Pen (Color.Black, 3);
        Rectangle r1 = new Rectangle (10,  10, 100, 100);
        Rectangle r2 = new Rectangle (120, 10, 100, 100);
        e.Graphics.DrawArc (p, r1, 0, -180);
        e.Graphics.DrawArc (p, r2, 0, 180);

        p.Dispose ();
    }
}
#endif

#if VERSION_03
class MyForm : Form
{
    // default c'tor
    public MyForm ()
    {
        // set caption bar text and size of this form
        this.Text = "Drawing Pies";
        this.BackColor = Color.White;
        this.ClientSize = new Size (230, 120);

        // control must be redrawn when it is resized
        this.ResizeRedraw = true;
    }

    // ellipsis
    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // draw two pies
        Rectangle r1 = new Rectangle (10,  10, 100,  100);
        Rectangle r2 = new Rectangle (120, 10, 100,  100);
        e.Graphics.FillPie (Brushes.Black, r1,   0, -270);
        e.Graphics.FillPie (Brushes.Black, r2, -90,  270);
    }
}
#endif

#if VERSION_04
class MyForm : Form
{
    // default c'tor
    public MyForm ()
    {
        // set caption bar text and size of this form
        this.Text = "Drawing Arcs";
        this.BackColor = Color.White;
        this.ClientSize = new Size (220, 120);

        // control must be redrawn when it is resized
        this.ResizeRedraw = true;
    }

    // ellipsis
    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // retrieve Graphics object to paint to the control
        Graphics g = e.Graphics;

        // draw two arcs
        Pen p = new Pen (Color.Black, 5);
        Rectangle r = new Rectangle (10, 10, 200, 100);
        g.DrawArc (p, r, 120, 220);
        p.Dispose ();
    }
}
#endif