#define VERSION_01
// #define VERSION_02

using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Drawing2D;

class Demo
{
    public static void Main ()
    {
        MyForm f = new MyForm ();
        Application.Run (f);
    }
}

#if VERSION_01
class MyForm : Form
{
    // default c'tor
    public MyForm ()
    {
        // set caption bar text and size of this form
        this.Text = "Drawing Polygons";
        this.BackColor = Color.White;
        this.ClientSize = new Size (343, 120);

        // control must be redrawn when it is resized
        this.ResizeRedraw = true;
    }

    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // create pen
        Pen p = new Pen (Color.Black, 3);

        // define some points
        Point p1 = new Point ( 60,   10);
        Point p2 = new Point (110,   60);
        Point p3 = new Point ( 60,  110);
        Point p4 = new Point ( 10,   60);

        // draw polygon
        Point[] curve1 = { p1, p2, p3, p4 };
        e.Graphics.DrawPolygon (p, curve1);

        // define some more points
        Point p5 = new Point (100 + 10,   10);
        Point p6 = new Point (100 + 110,  10);
        Point p7 = new Point (100 + 10,  110);
        Point p8 = new Point (100 + 110, 110);

        // draw another polygon
        Point[] curve2 = { p5, p6, p7, p8 };
        e.Graphics.DrawPolygon (p, curve2);

        // release resources
        p.Dispose ();
    }
}
#endif

#if VERSION_02
class MyForm : Form
{
    // default c'tor
    public MyForm ()
    {
        // set caption bar text and size of this form
        this.Text = "Alternate and Winding FillMode";
        this.BackColor = Color.White;
        this.ClientSize = new Size (480, 220);

        // control must be redrawn when it is resized
        this.ResizeRedraw = true;
    }

    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // define points of a pentagon
        Point p1 = new Point (  60,  200 );
        Point p2 = new Point ( 210,   90 );
        Point p3 = new Point (  20,   90 );
        Point p4 = new Point ( 170,  200 );
        Point p5 = new Point ( 115,   20 );
        Point p6 = new Point (  60,  200 );

        // draw pentagon, using fillmode 'Alternate'
        Point[] curve = { p1, p2, p3, p4, p5, p6 };
        e.Graphics.FillPolygon (Brushes.Black, curve, FillMode.Alternate);

        // move pentagon 250 pixels to the right
        for (int i = 0; i < curve.Length; i ++)
            curve[i].X += 250;

        // draw pentagon, using fillmode 'Winding'
        e.Graphics.FillPolygon (Brushes.Black, curve, FillMode.Winding);
    }
}
#endif