#define VERSION_01
// #define VERSION_02
// #define VERSION_04
// #define VERSION_05
// #define VERSION_06
// #define VERSION_07
// #define VERSION_08

using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Drawing2D;

class Demo
{
    public static void Main ()
    {
        MyForm f = new MyForm ();
        Application.Run (f);
    }
}

class MyForm : Form
{
    private const int x = 20;
    private const int y = 20;

    // default c'tor
    public MyForm ()
    {
        // set caption bar text and size of this form
        this.Text = "Solid Brush and Hatched Brush";
        // this.Text = "Lines and Pens";
        this.BackColor = Color.White;
        this.ClientSize = new Size (250, 100);

        // control must be redrawn when it is resized
        this.ResizeRedraw = true;
    }

#if VERSION_01
    // simple pen demonstration
    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // retrieve Graphics object to paint to the control
        Graphics g = e.Graphics;

        // create a blue-colored pen
        Pen p = new Pen (Color.Black);

        // set width of pen
        p.Width = 5;

        // draw two diagonal lines
        g.DrawLine (p, 10, 10, 90, 90);
        g.DrawLine (p, 10, 90, 90, 10);

        // release all resources
        p.Dispose ();
    }
#endif

#if VERSION_02
    // simple pen demonstration
    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // retrieve Graphics object to paint to the control
        Graphics g = e.Graphics;

        // draw two diagonal lines
        g.DrawLine (Pens.Black, 10, 10, 90, 90);
        g.DrawLine (Pens.Black, 10, 90, 90, 10);
    }
#endif

#if VERSION_03
    // testing 'SetPixel' workarounds
    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // retrieve Graphics object to paint to the control
        Graphics g = e.Graphics;

        // create a blue-colored pen
        Pen p = new Pen (Color.Blue);

        // set width of pen
        p.Width = 1;
        
        // draw two diagonal lines
//        Brush b = new SolidBrush (Color.Blue);
//        g.FillRectangle (b, 10, 10, 1, 1);
        g.DrawRectangle (p, 10, 10, 10, 0);

        // release all resources
        p.Dispose ();
    }
#endif

#if VERSION_04
    // testing LineCap's
    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // retrieve Graphics object to paint to the control
        Graphics g = e.Graphics;

        // create a pen
        Pen p = new Pen (Color.Black, 10);

        /*
        // demonstrate line begin and end
        p.StartCap = LineCap.Flat;
        p.EndCap = LineCap.Flat;
        g.DrawLine (p, 20, 20, 180, 20);

        p.StartCap = LineCap.Square;
        p.EndCap = LineCap.Square;
        g.DrawLine (p, 20, 20, 180, 20);

        p.StartCap = LineCap.SquareAnchor;
        p.EndCap = LineCap.SquareAnchor;
        g.DrawLine (p, 20, 20, 180, 20);

        p.StartCap = LineCap.Round;
        p.EndCap = LineCap.Round;
        g.DrawLine (p, 20, 20, 180, 20);

        p.StartCap = LineCap.RoundAnchor;
        p.EndCap = LineCap.RoundAnchor;
        g.DrawLine (p, 20, 20, 180, 20);

        p.StartCap = LineCap.DiamondAnchor;
        p.EndCap = LineCap.DiamondAnchor;
        g.DrawLine (p, 20, 20, 180, 20);

        p.StartCap = LineCap.ArrowAnchor;
        p.EndCap = LineCap.ArrowAnchor;
        g.DrawLine (p, 20, 20, 180, 20);
        */

        p.StartCap = LineCap.Triangle;
        p.EndCap = LineCap.Triangle;
        g.DrawLine (p, 20, 20, 180, 20);
        /*
        */
        
        // release all resources
        p.Dispose ();
    }
#endif

#if VERSION_05
    // simple pen demonstration
    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // retrieve Graphics object to paint to the control
        Graphics g = e.Graphics;

        // create a pen
//        Color c1 = Color.FromArgb (255, 155, 0);
//        Color c = Color.FromName ("grEn");
String s = KnownColor.Aquamarine.ToString ();
Color c = Color.FromName (s);
        Pen p = new Pen (c, 10);


        // draw two diagonal lines
        g.DrawLine (p, 10, 20, 190, 20);

        // release all resources
        p.Dispose ();
    }
#endif

#if VERSION_06
    // simple brush demonstration
    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // retrieve Graphics object to paint to the control
        Graphics g = e.Graphics;

        // create a solid brush ...
        Brush b1 = new SolidBrush (Color.Green);

        // ... and draw a filled rectangle
        g.FillRectangle (b1, 10, 10, 150, 30);

        // create a hatched brush ...
        Brush b2 = new HatchBrush (
            HatchStyle.Cross, Color.Yellow, Color.Black
        );

        // ... and draw a filled rectangle
        g.FillRectangle (b2, 200, 10, 150, 30);

        // release all resources
        b1.Dispose ();
        b2.Dispose ();
    }
#endif

#if VERSION_07
    // simple brush demonstration
    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // retrieve Graphics object to paint to the control
        Graphics g = e.Graphics;

        // create a hatched brush ...
        Brush b = new HatchBrush (
            HatchStyle.Horizontal, Color.Yellow, Color.Black
        );

        // ... and draw a filled rectangle
        g.FillRectangle (b, 10, 10, 180, 30);

        // release all resources
        b.Dispose ();
    }
#endif

#if VERSION_08
    // simple pen demonstration
    protected override void OnPaint (PaintEventArgs e)
    {
        // take care of registered delegates
        base.OnPaint (e);

        // retrieve Graphics object to paint to the control
        Graphics g = e.Graphics;

        // initialize a new FontFamily object with the specified name
        FontFamily family = new FontFamily ("Times New Roman");

        // initialize a new Font object using the specified properties
        Font font = new Font (
            family,           // font family
            22,               // size of the new font object
            FontStyle.Regular // font style to be applied
        );

        // draw some text string at the specified position
        PointF pointF = new PointF (30, 10);
        g.DrawString (
            "Hello World", // string to draw
            font,          // font object
            Brushes.Blue,  // brush object
            pointF         // PointF structure
        );

        // release all resources
        family.Dispose ();
        font.Dispose ();
    }
#endif
}
