// #define LISTING_01
// #define LISTING_02
#define LISTING_03

using System;
using System.Drawing;
using System.Windows.Forms;

#if LISTING_01
class Demo
{
    public static void Main ()
    {
        Form f1 = new Form ();
        Form f2 = new Form ();
        Form f3 = new Form ();
        Application.Run (f1);
        Application.Run (f2);
        Application.Run (f3);
    }
}
#endif

#if LISTING_02
class MultipleWindowsForm : Form
{
    // default c'tor
    public MultipleWindowsForm (String s)
    {
        // set caption bar text and size of this form
        this.Text = s;
        this.ClientSize = new Size (300, 60);
    }
}

class Demo
{
    public static void Main ()
    {
        Form f1 = new MultipleWindowsForm ("First Window");
        Form f2 = new MultipleWindowsForm ("Second Window");
        Form f3 = new MultipleWindowsForm ("Third Window");
        f1.Show ();
        f2.Show ();
        f3.Show ();

        Application.Run ();
    }
}
#endif

#if LISTING_03
class MultipleWindowsForm : Form
{
    private static int count = 0;

    // default c'tor
    public MultipleWindowsForm (String s)
    {
        // set caption bar text and size of this form
        this.Text = s;
        this.ClientSize = new Size (300, 60);

        // increment number of visible windows
        MultipleWindowsForm.count ++;
    }

    protected override void OnClosed (EventArgs e)
    {
        // enable registered clients to receive 'Closed' events
        base.OnClosed (e);

        // decrement number of visible windows
        MultipleWindowsForm.count --;
        if (MultipleWindowsForm.count == 0)
        {
            // no more windows visible, terminate application
            Application.Exit ();
        }
    }
}

class Demo
{
    public static void Main ()
    {
        Form f1 = new MultipleWindowsForm ("First Window");
        Form f2 = new MultipleWindowsForm ("Second Window");
        Form f3 = new MultipleWindowsForm ("Third Window");
        f1.Show ();
        f2.Show ();
        f3.Show ();

        Application.Run ();
    }
}
#endif
