using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;

class SimpleForm : Form
{
    private ProgressBar pb;

    public SimpleForm ()
    {
        // setup form
        this.ClientSize = new Size (360, 85);
        this.Text = "Component configuration without adapters";

        // setup 'increment' button
        Button b1 = new Button ();
        b1.Text = "Increment";
        b1.Click += new EventHandler (Button_Click_01);
        b1.Width = 100;
        b1.Location = new Point (10, 48);

        // setup 'decrement' button
        Button b2 = new Button ();
        b2.Text = "Decrement";
        b2.Click += new EventHandler (Button_Click_02);
        b2.Width = 100;
        b2.Location = new Point (250, 48);

        // setup progress bar
        this.pb = new ProgressBar ();
        this.pb.Location = new Point (10, 16);
        this.pb.Maximum = 20;
        this.pb.Width = 340;

        // add controls to container
        this.Controls.Add (b1);
        this.Controls.Add (b2);
        this.Controls.Add (this.pb);
    }

    private void Button_Click_01 (Object sender, EventArgs e)
    {
        if (this.pb.Value < this.pb.Maximum)
            this.pb.Value ++;
    }

    private void Button_Click_02 (Object sender, EventArgs e)
    {
        if (this.pb.Value > this.pb.Minimum)
            this.pb.Value --;
    }
}

class Demo
{
    public static void Main ()
    {
        SimpleForm f = new SimpleForm ();
        Application.Run (f);
    }
}