using System;
using System.Drawing;
using System.Windows.Forms;

class AdapterClickEventToValueProperty
{
    private ProgressBar target;
    private bool increment;

    public AdapterClickEventToValueProperty (
        Button source,
        ProgressBar target,
        bool increment)
    {
        this.target = target;
        this.increment = increment;

        // register handler method
        source.Click += new EventHandler (this.Button_Click);
    }
    
    private void Button_Click (Object sender, EventArgs e)
    {
        if (this.increment)
        {
            if (this.target.Value < this.target.Maximum)
                this.target.Value ++;
        }
        else
        {
            if (this.target.Value > this.target.Minimum)
                this.target.Value --;
        }
    }    
}

class SimpleForm : Form
{
    private ProgressBar pb;

    public SimpleForm ()
    {
        // setup form
        this.ClientSize = new Size (360, 85);
        this.Text = "Component configuration with adapters";

        // setup 'increment' button
        Button b1 = new Button ();
        b1.Text = "Increment";
        b1.Width = 100;
        b1.Location = new Point (10, 48);

        // setup 'decrement' button
        Button b2 = new Button ();
        b2.Text = "Decrement";
        b2.Width = 100;
        b2.Location = new Point (250, 48);

        // setup progress bar
        this.pb = new ProgressBar ();
        this.pb.Location = new Point (10, 16);
        this.pb.Maximum = 20;
        this.pb.Width = 340;

        // add controls to container
        this.Controls.Add (b1);
        this.Controls.Add (b2);
        this.Controls.Add (this.pb);

        // connect components
        AdapterClickEventToValueProperty adapter1 =
            new AdapterClickEventToValueProperty (b1, this.pb, true);

        AdapterClickEventToValueProperty adapter2 =
            new AdapterClickEventToValueProperty (b2, this.pb, false);
    }
}

class Demo
{
    public static void Main () 
    {
        SimpleForm f = new SimpleForm ();
        Application.Run (f);
    }
}