using System;
using System.Drawing;
using System.Windows.Forms;

class FourWinsForm : Form
{
    private FourWinsPanel panel;
    private TextBox tb;

    public FourWinsForm ()
    {
        this.Text = "Four Wins";
        this.Width = 400;
        this.Height = 400;

        // four wins panel
        this.panel = new FourWinsPanel ();
        this.panel.Width = 370;
        this.panel.Height = 320;
        this.panel.Left = 10;
        this.panel.Top = 40;
        this.panel.GameStatusChanged +=
            new GameStatusChangedEventHandler
                (this.FourWinsPanel_GameStatusChanged);
        this.Controls.Add (this.panel);

        // clear button
        Button b = new Button ();
        b.Text = "Clear";
        b.Left = 10;
        b.Top = 10;
        b.Width = 180;
        b.Click +=new EventHandler (this.Button_Click);
        this.Controls.Add (b);

        // status display
        this.tb = new TextBox ();
        this.tb.Multiline = false;
        this.tb.Text = "Start ...";
        this.tb.Left = 200;
        this.tb.Top = 10;
        this.tb.Width = 180;
        this.Controls.Add (this.tb);
    }

    public void Button_Click (Object sender, EventArgs e)
    {
        this.panel.ResetGame ();
        this.tb.Text = "Start ...";
    }

    void FourWinsPanel_GameStatusChanged
        (Object sender, GameStatusChangedEventArgs e)
    {
        GameStatus status = e.Status;

        switch (status)
        {
            case GameStatus.WhiteIsNext:
                this.tb.Text = "1. Player is next ...";
                break;

            case GameStatus.BlackIsNext:
                this.tb.Text = "2. Player is next ...";
                break;

            case GameStatus.WhiteHasWon:
                this.tb.Text = "1. Player has won !!!";
                break;

            case GameStatus.BlackHasWon:
                this.tb.Text = "2. Player has won !!!";
                break;
        }
    }
}
