using System;
using System.Drawing;
using System.Windows.Forms;

class EmployeeGroupBox : GroupBox
{
    private ListBox lb;

    public EmployeeGroupBox ()
    {
        // setup group box
        this.Text = "Employees";

        // setup list box
        this.lb = new ListBox ();
        this.lb.Items.Add ("Jim");
        this.lb.Items.Add ("Frank");
        this.lb.Items.Add ("Peter");
        this.lb.Items.Add ("Volker");
        this.lb.Items.Add ("Susan");
        this.lb.Dock = DockStyle.Fill;
        this.Controls.Add (this.lb);
    }
}

class DetailsGroupBox : GroupBox
{
    public DetailsGroupBox ()
    {
        // setup group box
        this.Text = "Details";
        this.Size = new Size (300, 200);

        // setup labels
        Label l1 = new Label ();
        l1.Location = new Point (8, 20);
        l1.Size = new Size (80, 20);
        l1.Text = "First Name:";
        l1.TextAlign = ContentAlignment.MiddleLeft;
        this.Controls.Add (l1);

        Label l2 = new Label ();
        l2.Location = new Point (8, 40);
        l2.Size = new Size (80, 20);
        l2.Text = "Last Name:";
        l2.TextAlign = ContentAlignment.MiddleLeft;
        this.Controls.Add (l2);

        Label l3 = new Label ();
        l3.Location = new Point (8, 60);
        l3.Size = new Size (80, 20);
        l3.Text = "Function:";
        l3.TextAlign = ContentAlignment.MiddleLeft;
        this.Controls.Add (l3);

        // setup text boxes
        TextBox tb1 = new TextBox ();
        tb1.Anchor = (
            AnchorStyles.Top |
            AnchorStyles.Left |
            AnchorStyles.Right
        );
        tb1.Size = new Size (180, 20);
        tb1.Location = new Point (100, 20);
        tb1.Text = "Jim";
        this.Controls.Add (tb1);

        TextBox tb2 = new TextBox ();
        tb2.Anchor = (
            AnchorStyles.Top |
            AnchorStyles.Left |
            AnchorStyles.Right
        );
        tb2.Size = new Size (180, 20);
        tb2.Location = new Point (100, 40);
        tb2.Text = "Benson";
        this.Controls.Add (tb2);

        TextBox tb3 = new TextBox ();
        tb3.Anchor = (
            AnchorStyles.Top |
            AnchorStyles.Left |
            AnchorStyles.Right
        );
        tb3.Size = new Size (180, 20);
        tb3.Location = new Point (100, 60);
        tb3.Text = "Programmer";
        this.Controls.Add (tb3);
    }
}

class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Layout: Grouping Demo";
        this.Size = new Size (500, 150);

        // setup left group box
        EmployeeGroupBox gp1 = new EmployeeGroupBox ();
        gp1.Width = this.ClientSize.Width / 3;
        gp1.Dock = DockStyle.Left;

        // setup right group box
        DetailsGroupBox gp2 = new DetailsGroupBox ();
        gp2.Dock = DockStyle.Fill;

        // setup split container
        SplitContainer sc = new SplitContainer ();
        sc.Panel1.Controls.Add (gp1);
        sc.Panel2.Controls.Add (gp2);
        sc.Orientation = Orientation.Vertical;
        sc.Dock = DockStyle.Fill;

        // add split container to the form
        this.Controls.Add (sc);
    }
}