// #define LISTING_01a   // Just a code fragment - does not compile
#define LISTING_01b
// #define LISTING_01c
// #define LISTING_01d
// #define LISTING_01e
// #define LISTING_01f
// #define LISTING_01g

using System;
using System.Drawing;
using System.Windows.Forms;

#if LISTING_01a
class MyControl : Control
{
}

class MyContainer : Form
{
    // member variable
    private MyControl ctrl;

    public MyContainer ()
    {
        // create control
        this.ctrl = new MyControl ();

        // setup control
        this.ctrl.BackColor = Color.Blue;

        // add control to container
        this.Controls.Add (this.ctrl);
    }
}
#endif

#if LISTING_01b
// anchoring
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Layout: Anchoring";
        this.Size = new Size (300, 200);

        // setup buttons
        Button b1 = new Button ();
        b1.Text = "Press me";
        b1.Anchor = AnchorStyles.Top | AnchorStyles.Left;
        b1.Location = new Point (10, 10);
        this.Controls.Add (b1);

        Button b2 = new Button ();
        b2.Text = "Press me";
        b2.Anchor = AnchorStyles.Bottom | AnchorStyles.Right;
        b2.Location = new Point (
            this.ClientSize.Width - b2.Width - 10,
            this.ClientSize.Height - b2.Height - 10
        );
        this.Controls.Add (b2);
    }
}
#endif

#if LISTING_01c
//class SimpleContainer : Form
//{
//    private Button b;                              // [step 1]
//
//    public SimpleContainer ()
//    {
//        this.b = new Button ();                    // [step 2]
//
//        this.b.Text = "Press me ...";              // [step 3]
//        this.b.Location = new Point (10, 10);
//
//        this.Controls.Add (this.b);                // [step 4]
//    }
//}
//
//class Demo
//{
//    public static void Main ()
//    {
//        SimpleContainer f = new SimpleContainer ();
//        Application.Run (f);
//    }
//}
#endif

#if LISTING_01d
// docking
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Layout: Docking";
        this.Size = new Size (300, 150);

        // setup button
        Button b = new Button ();
        b.Text = "Left";
        b.Dock = DockStyle.Left;
        this.Controls.Add (b);
    }
}
#endif

#if LISTING_01e
// z-order
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Layout: z-order";
        this.Size = new Size (300, 90);

        // setup buttons
        Button b1 = new Button ();
        Button b2 = new Button ();
        Button b3 = new Button ();

        b1.Text = "Button #1";
        b2.Text = "Button #2";
        b3.Text = "Button #3";

        b1.Location = new Point (50,  10);
        b2.Location = new Point (100, 20);
        b3.Location = new Point (150, 30);

        this.Controls.Add (b3);
        this.Controls.Add (b2);
        this.Controls.Add (b1);
    }
}
#endif

#if LISTING_01f
// simple text editor: size variant controls
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Layout: Very simple text editor";
        this.Size = new Size (300, 150);

        // setup top label
        Label l1 = new Label ();
        l1.Dock = DockStyle.Top;
        l1.Text = "Tool bar";

        // setup bottom label
        Label l2 = new Label ();
        l2.Dock = DockStyle.Bottom;
        l2.Text = "Status line";

        // setup text box
        TextBox tb = new TextBox ();
        tb.Multiline = true;
        String[] lines = {
            "The quick brown",
            "fox jumped over",
            "the lazy dogs."
        };
        tb.Lines = lines;
        tb.ScrollBars = ScrollBars.Vertical;
        tb.Dock = DockStyle.Fill;

        // add controls to container
        // (the order of the controls is critical !)
        this.Controls.Add (tb);
        this.Controls.Add (l1);
        this.Controls.Add (l2);
    }
}
#endif

#if LISTING_01g
// panel demo
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Layout: Panel demo";
        this.Size = new Size (400, 130);
   
        // setup panel
        Panel p = new Panel ();
        p.Location = new Point (10, 10);
        p.Size = new Size (200, 37);
        p.BorderStyle = BorderStyle.Fixed3D;

        // setup label
        Label l = new Label ();
        l.Location = new Point (4, 4);
        l.Text = "User Name:";
        l.TextAlign = ContentAlignment.MiddleCenter;
        l.Width = 65;

        // setup text box
        TextBox tb = new TextBox ();
        tb.Location = new Point (70, 7);
        tb.Width = 120;
        tb.Text = "Enter Name ...";

        // add controls to the panel
        p.Controls.Add (l);
        p.Controls.Add (tb);

        // add panel to the form
        this.Controls.Add (p);
    }
}
#endif
