#define LISTING_01a
// #define LISTING_01b
// #define LISTING_02a
// #define LISTING_02b
// #define LISTING_03a
// #define LISTING_04a
// #define LISTING_04b
// #define LISTING_05a
// #define LISTING_05b
// #define LISTING_05c
// #define LISTING_06a
// #define LISTING_06b
// #define LISTING_07a
// #define LISTING_07b
// #define LISTING_08a
// #define LISTING_08b
// #define LISTING_08c
// #define LISTING_09a
// #define LISTING_09b
// #define LISTING_10a

using System;
using System.Drawing;
using System.Windows.Forms;

#if LISTING_01a
// buttons
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Push Buttons";
        this.Size = new Size (350, 70);

        // setup two buttons
        Button b1 = new Button ();
        b1.Width = 100;
        b1.Text = "Press me";
        b1.FlatStyle = FlatStyle.Standard;
        b1.Location = new Point (10, 10);
        this.Controls.Add (b1);

        Button b2 = new Button ();
        b2.Width = 100;
        b2.Text = "Press me too";
        b2.FlatStyle = FlatStyle.Flat;
        b2.Location = new Point (120, 10);
        this.Controls.Add (b2);
    }
}
#endif

#if LISTING_01b
// buttons
class StandardWinForms : Form
{
    private int count = 0;

    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Push Buttons";
        this.Size = new Size (350, 70);

        // setup button
        Button b = new Button ();
        b.Text = "Press me";
        b.Click += new EventHandler (this.Button_Click);
        b.Location = new Point (10, 10);
        b.Width = 200;
        this.Controls.Add (b);
    }

    private void Button_Click (Object sender, EventArgs e)
    {
        this.count ++;
        this.Text = String.Format ("Button {0}. times pressed", this.count);
    }
}
#endif

#if LISTING_02a
// labels
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Labels";
        this.Size = new Size (540, 230);

        // setup labels
        Label l1 = new Label ();
        l1.Text = "This is a Label";
        l1.TextAlign = ContentAlignment.MiddleCenter;
        l1.Font = new Font ("Euclid", 12, FontStyle.Bold);
        l1.BackColor = Color.Yellow;
        l1.BorderStyle = BorderStyle.Fixed3D;
        l1.Location = new Point (10, 85);
        l1.Size = new Size (180, 30);
        this.Controls.Add (l1);

        Label l2 = new Label ();
        l2.Image = Image.FromFile ("..\\..\\Greece.bmp");
        l2.Location = new Point (210, 10);
        l2.Size = new Size (300, 180);
        this.Controls.Add (l2);
    }
}
#endif

#if LISTING_02b
// default values
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Standard Properties";
        this.Size = new Size (400, 120);

        // setup six labels
        Label l1 = new Label ();
        l1.Text = "Default Font:";
        l1.TextAlign = ContentAlignment.MiddleLeft;
        l1.Location = new Point (10, 10);
        l1.Width = 100;
        this.Controls.Add (l1);

        Label l2 = new Label ();
        l2.Text = FontFamily.GenericSansSerif.ToString ();
        l2.TextAlign = ContentAlignment.MiddleLeft;
        l2.Location = new Point (120, 10);
        l2.Width = 250;
        l2.BorderStyle = BorderStyle.Fixed3D;
        this.Controls.Add (l2);

        Label l3 = new Label ();
        l3.Text = "Default ForeColor:";
        l3.TextAlign = ContentAlignment.MiddleLeft;
        l3.Location = new Point (10, 35);
        l3.Width = 100;
        this.Controls.Add (l3);

        Label l4 = new Label ();
        String s = String.Format ("{0} [{1},{2},{3}]",
            SystemColors.ControlText.Name,
            SystemColors.ControlText.R,
            SystemColors.ControlText.G,
            SystemColors.ControlText.B
        );
        l4.Text = s;
        l4.TextAlign = ContentAlignment.MiddleLeft;
        l4.Location = new Point (120, 35);
        l4.Width = 250;
        l4.BorderStyle = BorderStyle.Fixed3D;
        this.Controls.Add (l4);

        Label l5 = new Label ();
        l5.Text = "Default BackColor:";
        l5.TextAlign = ContentAlignment.MiddleLeft;
        l5.Location = new Point (10, 60);
        l5.Width = 100;
        this.Controls.Add (l5);

        Label l6 = new Label ();
        s = String.Format ("{0} [{1},{2},{3}]",
            SystemColors.Control.Name,
            SystemColors.Control.R,
            SystemColors.Control.G,
            SystemColors.Control.B
        );
        l6.Text = s;
        l6.TextAlign = ContentAlignment.MiddleLeft;
        l6.Location = new Point (120, 60);
        l6.Width = 250;
        l6.BorderStyle = BorderStyle.Fixed3D;
        this.Controls.Add (l6);
    }
}
#endif

#if LISTING_03a
// text boxes
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Text boxes";
        this.Size = new Size (410, 150);

        // setup two text boxes
        TextBox tb1 = new TextBox ();
        tb1.Multiline = false;
        tb1.Text = "This is a single Line";
        tb1.TextAlign = HorizontalAlignment.Left;
        tb1.Font = new Font ("Courier", 12, FontStyle.Bold);
        tb1.BackColor = Color.Yellow;
        tb1.Select (0, 0);
        tb1.Location = new Point (10, 10);
        tb1.Size = new Size (180, 30);
        this.Controls.Add (tb1);

        TextBox tb2 = new TextBox ();
        tb2.Multiline = true;
        String[] lines = {
            "The quick brown",
            "fox jumped over",
            "the lazy dogs."
        };
        tb2.Lines = lines;
        tb2.Font = new Font ("Helvetica", 12, FontStyle.Bold);
        tb2.ScrollBars = ScrollBars.Vertical;
        tb2.Location = new Point (210, 10);
        tb2.Size = new Size (180, 100);
        this.Controls.Add (tb2);
    }
}
#endif

#if LISTING_04a
// check boxes and radio buttons
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Check boxes";
        this.Size = new Size (350, 90);

        // setup check boxes
        CheckBox cb1 = new CheckBox ();
        cb1.Text = "Match case";
        cb1.Width = 120;
        cb1.Location = new Point (10, 10);
        this.Controls.Add (cb1);

        CheckBox cb2 = new CheckBox ();
        cb2.Text = "Match whole word";
        cb2.Width = 120;
        cb2.Location = new Point (150, 10);
        this.Controls.Add (cb2);

        CheckBox cb3 = new CheckBox ();
        cb3.Text = "Search up";
        cb3.Width = 120;
        cb3.Location = new Point (10, 30);
        this.Controls.Add (cb3);

        CheckBox cb4 = new CheckBox ();
        cb4.Text = "Use regular expressions";
        cb4.Width = 150;
        cb4.Location = new Point (150, 30);
        this.Controls.Add (cb4);
    }
}
#endif

#if LISTING_04b
// check boxes
class StandardWinForms : Form
{
    private CheckBox cb;
    private Label l;

    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Check boxes";
        this.Size = new Size (350, 70);

        // setup check box
        this.cb = new CheckBox ();
        this.cb.Text = "Show Playlist";
        this.cb.Width = 120;
        this.cb.CheckedChanged +=
            new EventHandler (this.CheckBox_CheckedChanged);
        this.cb.Location = new Point (10, 10);
        this.Controls.Add (this.cb);

        // setup label
        this.l = new Label ();
        this.l.Text = String.Format
            ("Show Playlist is {0}", this.cb.Checked ? "on" : "off");
        this.l.BorderStyle = BorderStyle.Fixed3D;
        this.l.TextAlign = ContentAlignment.MiddleCenter;
        this.l.Height = cb.Height;
        this.l.Width = 150;
        this.l.Location = new Point (130, 10);
        this.Controls.Add (this.l);
    }

    private void CheckBox_CheckedChanged (Object sender, EventArgs e)
    {
        this.l.Text = String.Format ("Show Playlist is {0}",
            this.cb.Checked ? "on" : "off");
    }
}
#endif

#if LISTING_05a
// radio buttons
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Radio Buttons";
        this.Size = new Size (350, 70);

        // setup two radio buttons
        RadioButton rb1 = new RadioButton ();
        RadioButton rb2 = new RadioButton ();
        rb1.Text = "Volume On";
        rb2.Text = "Volume Off";
        rb1.Size = new Size (80, 20);
        rb2.Size = new Size (80, 20);
        rb1.Location = new Point (10, 10);
        rb2.Location = new Point (100, 10);
        rb1.Checked = true;
        rb2.Checked = false;
        this.Controls.Add (rb1);
        this.Controls.Add (rb2);
    }
}
#endif

#if LISTING_05b
// radio buttons
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Radio Buttons";
        this.Size = new Size (350, 130);

        // setup three radio buttons
        RadioButton rb1 = new RadioButton ();
        RadioButton rb2 = new RadioButton ();
        RadioButton rb3 = new RadioButton ();
        rb1.Text = "Fast";
        rb2.Text = "Normal";
        rb3.Text = "Slow";
        rb1.Size = new Size (80, 20);
        rb2.Size = new Size (80, 20);
        rb3.Size = new Size (80, 20);
        rb1.Location = new Point (10, 15);
        rb2.Location = new Point (10, 35);
        rb3.Location = new Point (10, 55);
        rb1.Checked = true;
        rb2.Checked = false;
        rb3.Checked = false;

        // setup radio button group
        GroupBox gb = new GroupBox ();
        gb.Size = new Size (100, 80);
        gb.Location = new Point (10, 10);
        gb.Text = "Play Speed";
        gb.Controls.Add (rb1);
        gb.Controls.Add (rb2);
        gb.Controls.Add (rb3);
        this.Controls.Add (gb);
    }
}
#endif

#if LISTING_05c
// radio buttons
class StandardWinForms : Form
{
    private Label l;

    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Radio Buttons";
        this.Size = new Size (350, 130);

        // setup label
        this.l = new Label ();
        this.l.Text = "Play Speed: Normal";
        this.l.TextAlign = ContentAlignment.MiddleLeft;
        this.l.Size = new Size (120, 20);
        this.l.Location = new Point (150, 45);
        this.Controls.Add (l);

        // setup three radio buttons
        RadioButton rb1 = new RadioButton ();
        RadioButton rb2 = new RadioButton ();
        RadioButton rb3 = new RadioButton ();
        rb1.Text = "Fast";
        rb2.Text = "Normal";
        rb3.Text = "Slow";
        rb1.Size = new Size (80, 20);
        rb2.Size = new Size (80, 20);
        rb3.Size = new Size (80, 20);
        rb1.Location = new Point (10, 15);
        rb2.Location = new Point (10, 35);
        rb3.Location = new Point (10, 55);
        rb1.Checked = false;
        rb2.Checked = true;
        rb3.Checked = false;

        // setup radio button group
        GroupBox gb = new GroupBox ();
        gb.Size = new Size (100, 80);
        gb.Location = new Point (10, 10);
        gb.Text = "Play Speed";
        gb.Controls.Add (rb1);
        gb.Controls.Add (rb2);
        gb.Controls.Add (rb3);
        this.Controls.Add (gb);

        // connect single event handler with three radio buttons
        EventHandler handler =
            new EventHandler (this.RadioButton_CheckedChanged);
        rb1.CheckedChanged += handler;
        rb2.CheckedChanged += handler;
        rb3.CheckedChanged += handler;
    }

    public void RadioButton_CheckedChanged (Object sender, EventArgs e)
    {
        RadioButton source = (RadioButton) sender;

        if (! source.Checked)
            return;

        this.l.Text = String.Format ("Play Speed: {0}", source.Text);
    }
}

#endif

#if LISTING_06a
// list boxes
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: List Boxes";
        this.Size = new Size (350, 140);

        // setup list box
        ListBox lb = new ListBox ();
        Type enumType = typeof (KnownColor);
        String[] colors = Enum.GetNames (enumType);
        for (int i = 0; i < colors.Length; i ++)
            lb.Items.Add (colors[i]);
        lb.SelectionMode = SelectionMode.One;
        lb.SelectedIndex = 1;
        lb.Size = new Size (130, 100);
        lb.Location = new Point (10, 10);
        this.Controls.Add (lb);
    }
}
#endif

#if LISTING_06b
// list boxes
class StandardWinForms : Form
{
    private ListBox left;
    private ListBox right;

    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: List Boxes";
        this.Size = new Size (350, 140);

        // setup first list box
        this.left = new ListBox ();
        Type enumType = typeof (KnownColor);
        String[] colors = Enum.GetNames (enumType);
        for (int i = 0; i < colors.Length; i ++)
            this.left.Items.Add (colors[i]);
        this.left.SelectionMode = SelectionMode.MultiExtended;
        this.left.SelectedIndexChanged
            += new EventHandler (this.ListBox_SelectedIndexChanged);
        this.left.Size = new Size (130, 100);
        this.left.Location = new Point (10, 10);
        this.Controls.Add (this.left);

        // setup second list box
        this.right = new ListBox ();
        this.right.SelectionMode = SelectionMode.None;
        this.right.Size = new Size (130, 100);
        this.right.Location = new Point (150, 10);
        this.Controls.Add (this.right);
    }

    private void ListBox_SelectedIndexChanged (Object sender, EventArgs e)
    {
        ListBox.SelectedObjectCollection selectedItems =
            this.left.SelectedItems;
        this.right.Items.Clear ();
        for (int i = 0; i < selectedItems.Count; i ++)
            this.right.Items.Add (selectedItems[i]);
    }
}
#endif

#if LISTING_07a
// combo boxes
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Combo Boxes";
        this.Size = new Size (350, 120);

        // create combo box
        ComboBox cb = new ComboBox ();

        // add employees
        cb.Items.Add ("Batista, Bernardo");
        cb.Items.Add ("Camino, Alejandra");
        cb.Items.Add ("Kloss, Horst");
        cb.Items.Add ("Limeira, Janete");
        cb.Items.Add ("Moroni, Maurizio");
        cb.Items.Add ("Pavarotti, Jose");
        cb.Items.Add ("Perrier, Dominique");
        cb.Items.Add ("Petersen, Jytte");
        cb.Items.Add ("Rodriguez, Lino");
        cb.Items.Add ("Wilson, Paula");

        // setup combo box 
        cb.DropDownStyle = ComboBoxStyle.DropDown;
        cb.MaxDropDownItems = 4;
        cb.SelectedIndex = 5;
        cb.Size = new Size (130, 100);
        cb.Location = new Point (10, 10);
        this.Controls.Add (cb);
    }
}
#endif

#if LISTING_07b
// checked listbox demo
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Checked ListBoxes";
        this.Size = new Size (360, 140);

        // create checked listbox
        CheckedListBox clb = new CheckedListBox ();

        // adding products
        clb.Items.Add ("Gustaf's Knckebrd");
        clb.Items.Add ("Rssle Sauerkraut");
        clb.Items.Add ("Gorgonzola Telino");
        clb.Items.Add ("Mascarpone Fabioli");
        clb.Items.Add ("Ipoh Coffee");
        clb.Items.Add ("Gula Malacca");
        clb.Items.Add ("Valkoinen suklaa");
        clb.Items.Add ("Manjimup Dried Apples");
        clb.Items.Add ("Gudbrandsdalsost");

        // setup checked listbox
        clb.SelectionMode = SelectionMode.One;
        clb.SetSelected (1, true);
        clb.SetItemChecked (0, true);
        clb.SetItemChecked (2, true);
        clb.Size = new Size (200, 100);
        clb.Location = new Point (10, 10);
        this.Controls.Add (clb);
    }
}
#endif

#if LISTING_08a
// scroll bar
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Scroll Bars";
        this.Size = new Size (350, 65);

        // setup scroll bar
        HScrollBar hsb = new HScrollBar ();
        hsb.Minimum = 0;
        hsb.Maximum = 100;
        hsb.Value = 50;
        hsb.LargeChange = 1;
        hsb.SmallChange = 1;
        hsb.Width = 300;
        hsb.Location = new Point (10, 10);
        this.Controls.Add (hsb);
    }
}
#endif

#if LISTING_08b
// scroll bar
class StandardWinForms : Form
{
    private HScrollBar hsb;
    private Label l;

    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Scroll Bars";
        this.Size = new Size (430, 65);

        // setup scroll bar
        this.hsb = new HScrollBar ();
        this.hsb.Minimum = 0;
        this.hsb.Maximum = 100;
        this.hsb.Value = 50;
        this.hsb.LargeChange = 1;
        this.hsb.SmallChange = 1;
        this.hsb.ValueChanged +=
            new EventHandler (this.HScrollBar_ValueChanged);
        this.hsb.Width = 300;
        this.hsb.Location = new Point (10, 10);
        this.Controls.Add (this.hsb);

        // setup label
        this.l = new Label ();
        this.l.Text = String.Format ("Value: {0}", hsb.Value);
        this.l.BorderStyle = BorderStyle.Fixed3D;
        this.l.TextAlign = ContentAlignment.MiddleCenter;
        this.l.Height = this.hsb.Height;
        this.l.Width = 80;
        this.l.Location = new Point (320, 10);
        this.Controls.Add (this.l);
    }

    private void HScrollBar_ValueChanged (Object sender, EventArgs e)
    {
        this.l.Text = String.Format ("Value: {0}", this.hsb.Value);
    }
}
#endif

#if LISTING_08c
// scroll bar
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Track Bars";
        this.Size = new Size (350, 90);

        // setup track bar
        TrackBar tb = new TrackBar ();
        tb.Minimum = 0;
        tb.Maximum = 100;
        tb.Value = 50;
        tb.LargeChange = 1;
        tb.SmallChange = 1;
        tb.TickFrequency = 5;
        tb.Width = 300;
        tb.Location = new Point (10, 10);
        this.Controls.Add (tb);
    }
}
#endif

#if LISTING_09a
// progress bar
class StandardWinForms : Form
{
    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Progress Bar";
        this.Size = new Size (350, 75);

        // setup progress bar
        ProgressBar pb = new ProgressBar ();
        pb.Minimum = 0;
        pb.Maximum = 100;
        pb.Value = 50;
        pb.Width = 300;
        pb.Location = new Point (10, 10);
        this.Controls.Add (pb);
    }
}
#endif

#if LISTING_09b
// progress bar
class StandardWinForms : Form
{
    private ProgressBar pb;
    private Button b1;
    private Button b2;

    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: Progress Bar";
        this.Size = new Size (350, 100);

        // setup progress bar
        this.pb = new ProgressBar ();
        this.pb.Minimum = 0;
        this.pb.Maximum = 100;
        this.pb.Value = 0;
        this.pb.Step = 1;
        this.pb.Width = 300;
        this.pb.Location = new Point (10, 10);
        this.Controls.Add (this.pb);

        // setup buttons
        this.b1 = new Button ();
        this.b1.Text = "<<<";
        EventHandler handler =
            new EventHandler (this.Button_Click);
        this.b1.Click += handler;
        this.b1.Location = new Point (10, 40);
        this.b1.Width = 100;
        this.Controls.Add (this.b1);

        this.b2 = new Button ();
        this.b2.Text = ">>>";
        this.b2.Click += handler;
        this.b2.Location = new Point (210, 40);
        this.b2.Width = 100;
        this.Controls.Add (this.b2);
    }

    private void Button_Click (Object sender, EventArgs e)
    {
        if (sender == this.b1)
        {
            this.pb.Increment (-1);
        }
        else if (sender == this.b2)
        {
            this.pb.Increment (1);
        }
    }
}
#endif

#if LISTING_10a
// NumericUpDown control
class StandardWinForms : Form
{
    private NumericUpDown updown;
    private Label l;

    public StandardWinForms ()
    {
        // setup form
        this.Text = "Standard WinForms Controls: NumericUpDown Control";
        this.Size = new Size (400, 100);

        // setup NumericUpDown control
        this.updown = new NumericUpDown ();
        this.updown.Width = 300;
        this.updown.Location = new Point (10, 10);
        this.updown.TextAlign = HorizontalAlignment.Center;
        this.updown.Value = 50;
        this.updown.Increment = 5;
        this.updown.Maximum = 100;
        this.updown.Minimum = 0;
        this.updown.ValueChanged +=
            new EventHandler (this.NumericUpDown_ValueChanged);
        this.Controls.Add (this.updown);

        // setup label
        this.l = new Label ();
        this.l.Width = 300;
        this.l.Location = new Point (10, 40);
        this.l.Text = String.Format ("Value: {0}", this.updown.Value);
        this.l.BorderStyle = BorderStyle.Fixed3D;
        this.l.TextAlign = ContentAlignment.MiddleCenter;
        this.Controls.Add (this.l);
    }

    private void NumericUpDown_ValueChanged (Object sender, EventArgs e)
    {
        this.l.Text = String.Format ("Value: {0}", this.updown.Value);
    }
}
#endif
