#define VERSION_01

using System;
using System.Drawing;
using System.Windows.Forms;

#if VERSION_01
class TrafficLightForm : Form
{
    public TrafficLightForm ()
    {
        // setup form
        this.Size = new Size (400, 340);
        this.Text = "Traffic Light Demo";

        // setup traffic light control
        TrafficLightControl tlc = new TrafficLightControl ();
        tlc.Location = new Point (10, 10);
        this.Controls.Add (tlc);
    }
}
#endif

#if VERSION_02
class TrafficLightForm : Form
{
    private TrafficLightControl tlc;
    private Button b1;
    private Button b2;
    private Button b3;
    private Button b4;

    public TrafficLightForm ()
    {
        // setup form
        this.Size = new Size (400, 340);
        this.Text = "Traffic Light Demo";

        // setup traffic light control
        this.tlc = new TrafficLightControl ();
        this.tlc.Location = new Point (10, 10);
        this.Controls.Add (this.tlc);

        // setup four buttons
        this.b1 = new Button ();
        this.b2 = new Button ();
        this.b3 = new Button ();
        this.b4 = new Button ();
        this.b1.Text = "Red";
        this.b2.Text = "Red-Yellow";
        this.b3.Text = "Yellow";
        this.b4.Text = "Green";
        this.b1.Location = new Point (150, 10);
        this.b2.Location = new Point (150, 40);
        this.b3.Location = new Point (150, 70);
        this.b4.Location = new Point (150, 100);
        this.b1.BackColor = Color.LightGray;
        this.b2.BackColor = Color.LightGray;
        this.b3.BackColor = Color.LightGray;
        this.b4.BackColor = Color.LightGray;
        this.b1.Size = new Size (200, 23);
        this.b2.Size = new Size (200, 23);
        this.b3.Size = new Size (200, 23);
        this.b4.Size = new Size (200, 23);
        this.b1.Click += new EventHandler (this.Button_Click01);
        this.b2.Click += new EventHandler (this.Button_Click02);
        this.b3.Click += new EventHandler (this.Button_Click03);
        this.b4.Click += new EventHandler (this.Button_Click04);
        this.Controls.Add (this.b1);
        this.Controls.Add (this.b2);
        this.Controls.Add (this.b3);
        this.Controls.Add (this.b4);
    }

    private void Button_Click01 (Object sender, EventArgs e)
    {
        this.tlc.Status = TrafficLightStatus.Red;
    }
    
    private void Button_Click02 (Object sender, EventArgs e)
    {
        this.tlc.Status = TrafficLightStatus.RedYellow;
    }
    
    private void Button_Click03 (Object sender, EventArgs e)
    {
        this.tlc.Status = TrafficLightStatus.Yellow;
    }
    
    private void Button_Click04 (Object sender, EventArgs e)
    {
        this.tlc.Status = TrafficLightStatus.Green;
    }
}
#endif

#if VERSION_03
class TrafficLightForm : Form
{
    private TrafficLightControl tlc;
    private Button b1;
    private Button b2;

    public TrafficLightForm ()
    {
        // setup form
        this.Size = new Size (400, 340);
        this.Text = "Traffic Light Demo";

        // traffic light control
        this.tlc = new TrafficLightControl ();
        this.tlc.Location = new Point (10, 10);
        this.Controls.Add (this.tlc);

        // create button to test 'SwitchToRed' method
        this.b1 = new Button ();
        this.b1.Text = "Switch to Red";
        this.b1.Location = new Point (150, 10);
        this.b1.BackColor = Color.LightGray;
        this.b1.Size = new Size (200, 23);
        this.b1.Click += new EventHandler (this.ClickHandler1);
        this.Controls.Add (this.b1);

        // create button to test 'SwitchToGreen' method
        this.b2 = new Button ();
        this.b2.Text = "Switch to Green";
        this.b2.Location = new Point (150, 40);
        this.b2.BackColor = Color.LightGray;
        this.b2.Size = new Size (200, 23);
        this.b2.Click += new EventHandler (this.ClickHandler2);
        this.Controls.Add (this.b2);
    }

    private void ClickHandler1 (Object sender, EventArgs e)
    {
        this.tlc.SwitchToRed ();
    }

    private void ClickHandler2 (Object sender, EventArgs e)
    {
        this.tlc.SwitchToGreen ();
    }
}
#endif

#if VERSION_04
class TrafficLightForm : Form
{
    private TrafficLightControl tlc;
    private Button b;
    private TextBox tb;

    public TrafficLightForm ()
    {
        // setup form
        this.Size = new Size (400, 340);
        this.Text = "Traffic Light Demo";

        // traffic light control
        this.tlc = new TrafficLightControl ();
        this.tlc.Location = new Point (10, 10);
        this.Controls.Add (this.tlc);

        // create button to set status
        this.b = new Button ();
        this.b.Text = "Set Status";
        this.b.Location = new Point (150, 10);
        this.b.BackColor = Color.LightGray;
        this.b.Size = new Size (200, 23);
        this.b.Click += new EventHandler (this.ClickHandler);
        this.Controls.Add (this.b);

        // create text box
        this.tb = new TextBox ();
        this.tb.Location = new Point (150, 40);
        this.tb.BackColor = Color.LightGray;
        this.tb.Size = new Size (200, 23);
        this.Controls.Add (this.tb);

        // add 'StatusChanged' event handler to traffic light control
        this.tlc.StatusChanged +=
            new StatusChangedEventHandler (this.GotStatusChanged);
    }

    private void ClickHandler (Object sender, EventArgs e)
    {
        TrafficLightStatus s = this.tlc.Status;

        switch (s)
        {
            case TrafficLightStatus.Red:
                this.tlc.Status = TrafficLightStatus.RedYellow;
                break;

            case TrafficLightStatus.RedYellow:
                this.tlc.Status = TrafficLightStatus.Yellow;
                break;

            case TrafficLightStatus.Yellow:
                this.tlc.Status = TrafficLightStatus.Green;
                break;

            case TrafficLightStatus.Green:
                this.tlc.Status = TrafficLightStatus.Red;
                break;
        }
    }

    private void GotStatusChanged (Object sender, StatusChangedEventArgs args)
    {
        this.tb.Text = args.Status.ToString ();
    }
}
#endif

#if VERSION_04a

class SwitchButton : Button
{
    private TrafficLightControl tlc;

    public SwitchButton (TrafficLightControl tlc)
    {
        // setup button
        this.Text = "Set Status";
        this.BackColor = Color.LightGray;
        this.Size = new Size (200, 23);
        this.Click += new EventHandler (this.Button_Click);

        // store connected traffic light control
        this.tlc = tlc;
    }

    private void Button_Click (Object sender, EventArgs e)
    {
        TrafficLightStatus s = this.tlc.Status;

        switch (s)
        {
            case TrafficLightStatus.Red:
                this.tlc.Status = TrafficLightStatus.RedYellow;
                break;

            case TrafficLightStatus.RedYellow:
                this.tlc.Status = TrafficLightStatus.Yellow;
                break;

            case TrafficLightStatus.Yellow:
                this.tlc.Status = TrafficLightStatus.Green;
                break;

            case TrafficLightStatus.Green:
                this.tlc.Status = TrafficLightStatus.Red;
                break;
        }
    }
}

class StatusTextBox : TextBox
{
    public StatusTextBox (TrafficLightControl tlc)
    {
        // setup textbox
        this.BackColor = Color.LightGray;
        this.Size = new Size (200, 23);

        // add event handler to traffic light control
        tlc.StatusChanged +=
            new StatusChangedEventHandler (this.TrafficLight_StatusChanged);
    }

    private void TrafficLight_StatusChanged
        (Object sender, StatusChangedEventArgs args)
    {
        this.Text = args.Status.ToString ();
    }
}

class TrafficLightForm : Form
{
    private TrafficLightControl tlc;
    private SwitchButton b;
    private StatusTextBox tb;

    public TrafficLightForm ()
    {
        // setup form
        this.Size = new Size (400, 340);
        this.Text = "Traffic Light Demo";

        // setup traffic light control
        this.tlc = new TrafficLightControl ();
        this.tlc.Location = new Point (10, 10);
        this.Controls.Add (this.tlc);

        // setup specialized button to set status
        this.b = new SwitchButton (this.tlc);
        this.b.Location = new Point (150, 10);
        this.Controls.Add (this.b);

        // setup specialized text box to display traffic light status
        this.tb = new StatusTextBox (this.tlc);
        this.tb.Location = new Point (150, 40);
        this.Controls.Add (this.tb);
    }
}
#endif

#if VERSION_05
class TrafficLightForm : Form
{
    private TrafficLightControl tlc1;
    private TrafficLightControl tlc2;
    private Button b1;
    private Button b2;

    public TrafficLightForm ()
    {
        // setup form
        this.Size = new Size (460, 370);
        this.Text = "Traffic Light Demo";

        // setup left traffic light control
        this.tlc1 = new TrafficLightControl ();
        this.tlc1.Location = new Point (80, 10);
        this.tlc1.Name = "Left";
        this.Controls.Add (this.tlc1);

        // setup right traffic light control
        this.tlc2 = new TrafficLightControl ();
        this.tlc2.Location = new Point (280, 10);
        this.tlc2.Name = "Right";
        this.tlc2.Status = TrafficLightStatus.Green;
        this.Controls.Add (this.tlc2);

        // create buttons to test 'SwitchToGreen' method
        this.b1 = new Button ();
        this.b1.Text = "Switch to Green";
        this.b1.Location = new Point (60, 310);
        this.b1.BackColor = Color.LightGray;
        this.b1.Size = new Size (140, 23);
        this.b1.Click += new EventHandler (this.Button_Click);
        this.Controls.Add (this.b1);

        this.b2 = new Button ();
        this.b2.Text = "Switch to Green";
        this.b2.Location = new Point (260, 310);
        this.b2.BackColor = Color.LightGray;
        this.b2.Size = new Size (140, 23);
        this.b2.Click += new EventHandler (this.Button_Click);
        this.Controls.Add (this.b2);

        // connect traffic lights
        this.tlc1.RedRequest +=
            new RedRequestEventHandler (this.GotRedRequest1);
        this.tlc2.RedRequest +=
            new RedRequestEventHandler (this.GotRedRequest2);
        this.tlc1.RedAcknowledge +=
            new RedAcknowledgeEventHandler (this.GotRedAcknowledge1);
        this.tlc2.RedAcknowledge +=
            new RedAcknowledgeEventHandler (this.GotRedAcknowledge2);
    }

    private void Button_Click (Object sender, EventArgs e)
    {
        if (sender == b1)
            this.tlc1.SwitchToGreen ();
        else if (sender == b2)
            this.tlc2.SwitchToGreen ();
    }

    private void GotRedRequest1 (Object sender, EventArgs e)
    {
        this.tlc2.SwitchToRed ();
    }

    private void GotRedRequest2 (Object sender, EventArgs e)
    {
        this.tlc1.SwitchToRed ();
    }

    private void GotRedAcknowledge1 (Object sender, EventArgs e)
    {
        this.tlc2.ResumeSwitchToGreen ();
    }

    private void GotRedAcknowledge2 (Object sender, EventArgs e)
    {
        this.tlc1.ResumeSwitchToGreen ();
    }
}
#endif

#if VERSION_06
class TrafficLightForm : Form
{
    private TrafficLightControl tlc1;
    private TrafficLightControl tlc2;
    private Button b1;
    private Button b2;

    public TrafficLightForm ()
    {
        // setup form
        this.Size = new Size (460, 370);
        this.Text = "Traffic Light Demo";

        // setup left traffic light control
        this.tlc1 = new TrafficLightControl ();
        this.tlc1.Location = new Point (80, 10);
        this.tlc1.Name = "Left";
        this.Controls.Add (this.tlc1);

        // setup right traffic light control
        this.tlc2 = new TrafficLightControl ();
        this.tlc2.Location = new Point (280, 10);
        this.tlc2.Name = "Right";
        this.tlc2.Status = TrafficLightStatus.Green;
        this.Controls.Add (this.tlc2);

        // create buttons to test 'SwitchToGreen' method
        this.b1 = new Button ();
        this.b1.Text = "Switch to Green";
        this.b1.Location = new Point (60, 310);
        this.b1.BackColor = Color.LightGray;
        this.b1.Size = new Size (140, 23);
        this.b1.Click += new EventHandler (this.Button_Click);
        this.Controls.Add (this.b1);

        this.b2 = new Button ();
        this.b2.Text = "Switch to Green";
        this.b2.Location = new Point (260, 310);
        this.b2.BackColor = Color.LightGray;
        this.b2.Size = new Size (140, 23);
        this.b2.Click += new EventHandler (this.Button_Click);
        this.Controls.Add (this.b2);

        // connect traffic lights
        RedRequestAdapter adap1 =
            new RedRequestAdapter (this.tlc1, this.tlc2);
        RedRequestAdapter adap2 =
            new RedRequestAdapter (this.tlc2, this.tlc1);

        RedAcknowledgeAdapter adap3 =
            new RedAcknowledgeAdapter (this.tlc1, this.tlc2);
        RedAcknowledgeAdapter adap4 =
            new RedAcknowledgeAdapter (this.tlc2, this.tlc1);
    }

    private void Button_Click (Object sender, EventArgs e)
    {
        if (sender == b1)
            this.tlc1.SwitchToGreen ();
        else if (sender == b2)
            this.tlc2.SwitchToGreen ();
    }
}
#endif

#if VERSION_07
class TrafficLightForm : Form
{
    public TrafficLightForm ()
    {
        // setup first traffic light control -
        // add a panel into the form and host
        // the traffic light control in the panel
        TrafficLight tl1 = new TrafficLight ();
        tl1.Dock = DockStyle.Fill;
        Panel p1 = new Panel();
        p1.BorderStyle = BorderStyle.FixedSingle;
        p1.Size = tl1.Size;
        p1.Location = new Point (20, 5);
        p1.Controls.Add (tl1);
        this.Controls.Add (p1);

        // setup second traffic light control
        TrafficLight tl2 = new TrafficLight ();
        tl2.Dock = DockStyle.Fill;
        Panel p2 = new Panel();
        p2.BorderStyle = BorderStyle.FixedSingle;
        p2.Size = tl2.Size;
        p2.Location = new Point (40 + p1.Width, 5);
        p2.Controls.Add (tl2);
        this.Controls.Add (p2);

        // setup form
        this.ClientSize = new Size (p1.Width + p2.Width + 60, p1.Height + 10);
        this.Text = "Traffic Light Demo using UserControls";
    }
}
#endif

#if VERSION_MVC
class TrafficLightForm : Form
{
    public TrafficLightForm ()
    {
        // setup form
        this.Size = new Size (440, 340);
        this.Text = "Traffic Light Demo " +
                    "(using Model-View-Controller Architecture)";

        // creating a model
        ITrafficLightModel model = new TrafficLightModelImpl ();

        // creating a view (being connected to the model)
        TrafficLightView view = new TrafficLightView (model);
        view.Location = new Point (10, 10);

        // creating a second view (being connected to the model)
        TextBoxView textboxView = new TextBoxView (model);
        textboxView.Location = new Point (150, 70);

        // creating a controller (being connected to the model)
        TrafficLightRedController redController =
            new TrafficLightRedController (model);
        redController.Location = new Point (150, 10);

        // creating a second controller (being connected to the model)
        TrafficLightGreenController greenController =
            new TrafficLightGreenController (model);
        greenController.Location = new Point (150, 40);

        // add controls to the container
        this.Controls.Add (view);
        this.Controls.Add (textboxView);
        this.Controls.Add (redController);
        this.Controls.Add (greenController);
    }
}
#endif
