using System;
using System.Drawing;
using System.Windows.Forms;

public class PositionView : Panel
{
    private Label lX;
    private Label lY;

    private Control view;

    public PositionView (Control view)
    {
        this.view = view;

        // setup container
        this.BorderStyle = BorderStyle.None;
        this.ClientSize = new Size (125, 20);

        // setup two labels
        this.lX = new Label ();
        this.lX.TextAlign = ContentAlignment.MiddleCenter;
        this.lX.Text = "0";
        this.lX.BorderStyle = BorderStyle.Fixed3D;
        this.lX.Width = 60;
        this.lX.Dock = DockStyle.Left;

        this.lY = new Label ();
        this.lY.TextAlign = ContentAlignment.MiddleCenter;
        this.lY.Text = "0";
        this.lY.BorderStyle = BorderStyle.Fixed3D;
        this.lY.Width = 60;
        this.lY.Dock = DockStyle.Right;

        // create and register event sink
        MouseEventHandler handler = new MouseEventHandler (this.OnMouseMove);
        this.view.MouseMove += new MouseEventHandler (handler);

        // add controls to container
        this.Controls.Add (this.lX);
        this.Controls.Add (this.lY);
    }

    public void OnMouseMove (Object sender, MouseEventArgs e)
    {
        this.lX.Text = e.X.ToString ();
        this.lY.Text = e.Y.ToString ();
    }
}
