using System;
using System.Drawing;
using System.Windows.Forms;

class CAModulo2 : Form
{
    public CAModulo2 ()
    {
        this.Text = "Linear Cellular Automaton: Modulo-2";
        this.ClientSize = new Size (400, 200);
        this.BackColor = Color.White;

        // control must be redrawn when it is resized
        this.ResizeRedraw = true;
    }

    protected override void OnPaint (PaintEventArgs e)
    {
        // enable registered clients to receive 'Paint' events
        base.OnPaint(e);
        
        // setup first generation
        int[] cells = new int[this.ClientSize.Width];
        int[] last = new int[this.ClientSize.Width];
        int middle = this.ClientSize.Width / 2;
        cells[middle] = 1;

        Graphics g = e.Graphics;
        for (int r = 0; r < this.ClientSize.Height; r ++)
        {
            // draw current generation
            for (int c = middle - r; c <= middle + r; c ++)
            {
                Brush br = (cells[c] != 0) ? 
                    Brushes.Black : Brushes.White;                
                g.FillRectangle (br, c, r, 1, 1);
            }

            // calculate next generation
            if (middle - r >= 2 && middle + r <= this.ClientSize.Width - 3)
            {
                for (int i = middle - r - 1; i <= middle + r + 1; i ++)
                {
                    last[i] = (((cells[i-1] + cells[i+1]) % 2) == 0) ? 0 : 1;
                }

                // swap lines
                int[] tmp = cells;
                cells = last;
                last = tmp;
            }
            else
                break;
        }
    }
}
