#define THREAD_01
// #define THREAD_02

using System;
using System.Threading;

class Target
{
    public static long value = 0;
    public const int Max = 10000000;
}

#if THREAD_01
class Incrementer
{
    public static void Increment ()
    {
        for (int i = 0; i < Target.Max; i ++)
            Target.value ++;
    }
}

class Decrementer
{
    public static void Decrement ()
    {
        for (int i = 0; i < Target.Max; i ++)
            Target.value --;
    }
}
#endif

#if THREAD_02
class Incrementer
{
    public static void Increment ()
    {
        for (int i = 0; i < Target.Max; i ++)
            Interlocked.Increment (ref Target.value);
    }
}

class Decrementer
{
    public static void Decrement ()
    {
        for (int i = 0; i < Target.Max; i ++)
            Interlocked.Decrement (ref Target.value);
    }
}
#endif

class Demo
{
    public static void Main ()
    {
        Thread t1 = new Thread (new ThreadStart (Incrementer.Increment));
        Thread t2 = new Thread (new ThreadStart (Decrementer.Decrement));

        Console.WriteLine ("{0}", Target.value);
        int ticks = Environment.TickCount;
        t1.Start ();
        t2.Start ();
        t1.Join ();
        t2.Join ();
        int milliSeconds = Environment.TickCount - ticks;
        Console.WriteLine ("{0} [{1} msecs]", Target.value, milliSeconds);
    }
}
