#define PICTURE_01
// #define PICTURE_02
// #define PICTURE_03

#if PICTURE_01
#define ITERATION_100
#endif

#if PICTURE_02
#define ITERATION_200
#endif

#if PICTURE_03
#define ITERATION_200
#endif

using System.Drawing;

class MandelbrotCoords
{
#if PICTURE_01
    // original limits (iteration of 100 recommended)
    public const double XMin = -2.0;   // minimum x-value (real part)
    public const double XMax = +0.75;  // maximum x-value (real part)
    public const double YMin = -1.25;  // minimum y-value (imaginary part)
    public const double YMax = +1.25;  // maximum y-value (imaginary part)
#endif

#if PICTURE_02
    // another fine picture
    // original limits (iteration of 200 recommended)
    public const double XMin = -0.745468;  // minimum x-value (real part)
    public const double XMax = -0.745385;  // maximum x-value (real part)
    public const double YMin = +0.112975;  // minimum y-value (imaginary part)
    public const double YMax = +0.113044;  // maximum y-value (imaginary part)
#endif

#if PICTURE_03
    // another fine picture
    // original limits (iteration of 200 recommended)
    public const double XMin = -0.74581;  // minimum x-value (real part)
    public const double XMax = -0.74448;  // maximum x-value (real part)
    public const double YMin = +0.11196;  // minimum y-value (imaginary part)
    public const double YMax = +0.11339;  // maximum y-value (imaginary part)
#endif

    public const double XWidth = XMax - XMin;  // range of x-values
    public const double YHeight = YMax - YMin; // range of y-values
}

#if ITERATION_100
class MandelbrotColors
{
	public const int MaxIterations = 100;  // maximum number of iterations

	public static Color [] HSBColors  = 
	{
		Color.FromArgb (255, 0, 0),
		Color.FromArgb (255, 15, 0),
		Color.FromArgb (255, 31, 0),
		Color.FromArgb (255, 46, 0),
		Color.FromArgb (255, 61, 0),
		Color.FromArgb (255, 77, 0),
		Color.FromArgb (255, 92, 0),
		Color.FromArgb (255, 107, 0),
		Color.FromArgb (255, 122, 0),
		Color.FromArgb (255, 138, 0),
		Color.FromArgb (255, 153, 0),
		Color.FromArgb (255, 168, 0),
		Color.FromArgb (255, 184, 0),
		Color.FromArgb (255, 199, 0),
		Color.FromArgb (255, 214, 0),
		Color.FromArgb (255, 230, 0),
		Color.FromArgb (255, 245, 0),
		Color.FromArgb (250, 255, 0),
		Color.FromArgb (235, 255, 0),
		Color.FromArgb (219, 255, 0),
		Color.FromArgb (204, 255, 0),
		Color.FromArgb (189, 255, 0),
		Color.FromArgb (173, 255, 0),
		Color.FromArgb (158, 255, 0),
		Color.FromArgb (143, 255, 0),
		Color.FromArgb (128, 255, 0),
		Color.FromArgb (112, 255, 0),
		Color.FromArgb (97, 255, 0),
		Color.FromArgb (82, 255, 0),
		Color.FromArgb (66, 255, 0),
		Color.FromArgb (51, 255, 0),
		Color.FromArgb (36, 255, 0),
		Color.FromArgb (20, 255, 0),
		Color.FromArgb (5, 255, 0),
		Color.FromArgb (0, 255, 10),
		Color.FromArgb (0, 255, 25),
		Color.FromArgb (0, 255, 41),
		Color.FromArgb (0, 255, 56),
		Color.FromArgb (0, 255, 71),
		Color.FromArgb (0, 255, 87),
		Color.FromArgb (0, 255, 102),
		Color.FromArgb (0, 255, 117),
		Color.FromArgb (0, 255, 133),
		Color.FromArgb (0, 255, 148),
		Color.FromArgb (0, 255, 163),
		Color.FromArgb (0, 255, 178),
		Color.FromArgb (0, 255, 194),
		Color.FromArgb (0, 255, 209),
		Color.FromArgb (0, 255, 224),
		Color.FromArgb (0, 255, 240),
		Color.FromArgb (0, 255, 255),
		Color.FromArgb (0, 240, 255),
		Color.FromArgb (0, 224, 255),
		Color.FromArgb (0, 209, 255),
		Color.FromArgb (0, 194, 255),
		Color.FromArgb (0, 178, 255),
		Color.FromArgb (0, 163, 255),
		Color.FromArgb (0, 148, 255),
		Color.FromArgb (0, 133, 255),
		Color.FromArgb (0, 117, 255),
		Color.FromArgb (0, 102, 255),
		Color.FromArgb (0, 87, 255),
		Color.FromArgb (0, 71, 255),
		Color.FromArgb (0, 56, 255),
		Color.FromArgb (0, 41, 255),
		Color.FromArgb (0, 26, 255),
		Color.FromArgb (0, 10, 255),
		Color.FromArgb (5, 0, 255),
		Color.FromArgb (20, 0, 255),
		Color.FromArgb (36, 0, 255),
		Color.FromArgb (51, 0, 255),
		Color.FromArgb (66, 0, 255),
		Color.FromArgb (82, 0, 255),
		Color.FromArgb (97, 0, 255),
		Color.FromArgb (112, 0, 255),
		Color.FromArgb (128, 0, 255),
		Color.FromArgb (143, 0, 255),
		Color.FromArgb (158, 0, 255),
		Color.FromArgb (173, 0, 255),
		Color.FromArgb (189, 0, 255),
		Color.FromArgb (204, 0, 255),
		Color.FromArgb (219, 0, 255),
		Color.FromArgb (235, 0, 255),
		Color.FromArgb (250, 0, 255),
		Color.FromArgb (255, 0, 245),
		Color.FromArgb (255, 0, 229),
		Color.FromArgb (255, 0, 214),
		Color.FromArgb (255, 0, 199),
		Color.FromArgb (255, 0, 184),
		Color.FromArgb (255, 0, 168),
		Color.FromArgb (255, 0, 153),
		Color.FromArgb (255, 0, 138),
		Color.FromArgb (255, 0, 122),
		Color.FromArgb (255, 0, 107),
		Color.FromArgb (255, 0, 92),
		Color.FromArgb (255, 0, 77),
		Color.FromArgb (255, 0, 61),
		Color.FromArgb (255, 0, 46),
		Color.FromArgb (255, 0, 31),
		Color.FromArgb (255, 0, 15),
	};
}
#endif

#if ITERATION_200
public class MandelbrotColors
{
	public const int MaxIterations = 200;  // maximum number of iterations

	public static Color [] HSBColors  = 
	{
		Color.FromArgb (255, 0, 0),
		Color.FromArgb (255, 8, 0),
		Color.FromArgb (255, 15, 0),
		Color.FromArgb (255, 23, 0),
		Color.FromArgb (255, 31, 0),
		Color.FromArgb (255, 38, 0),
		Color.FromArgb (255, 46, 0),
		Color.FromArgb (255, 54, 0),
		Color.FromArgb (255, 61, 0),
		Color.FromArgb (255, 69, 0),
		Color.FromArgb (255, 77, 0),
		Color.FromArgb (255, 84, 0),
		Color.FromArgb (255, 92, 0),
		Color.FromArgb (255, 99, 0),
		Color.FromArgb (255, 107, 0),
		Color.FromArgb (255, 115, 0),
		Color.FromArgb (255, 122, 0),
		Color.FromArgb (255, 130, 0),
		Color.FromArgb (255, 138, 0),
		Color.FromArgb (255, 145, 0),
		Color.FromArgb (255, 153, 0),
		Color.FromArgb (255, 161, 0),
		Color.FromArgb (255, 168, 0),
		Color.FromArgb (255, 176, 0),
		Color.FromArgb (255, 184, 0),
		Color.FromArgb (255, 191, 0),
		Color.FromArgb (255, 199, 0),
		Color.FromArgb (255, 207, 0),
		Color.FromArgb (255, 214, 0),
		Color.FromArgb (255, 222, 0),
		Color.FromArgb (255, 230, 0),
		Color.FromArgb (255, 237, 0),
		Color.FromArgb (255, 245, 0),
		Color.FromArgb (255, 252, 0),
		Color.FromArgb (250, 255, 0),
		Color.FromArgb (242, 255, 0),
		Color.FromArgb (235, 255, 0),
		Color.FromArgb (227, 255, 0),
		Color.FromArgb (219, 255, 0),
		Color.FromArgb (212, 255, 0),
		Color.FromArgb (204, 255, 0),
		Color.FromArgb (196, 255, 0),
		Color.FromArgb (189, 255, 0),
		Color.FromArgb (181, 255, 0),
		Color.FromArgb (173, 255, 0),
		Color.FromArgb (166, 255, 0),
		Color.FromArgb (158, 255, 0),
		Color.FromArgb (150, 255, 0),
		Color.FromArgb (143, 255, 0),
		Color.FromArgb (135, 255, 0),
		Color.FromArgb (128, 255, 0),
		Color.FromArgb (120, 255, 0),
		Color.FromArgb (112, 255, 0),
		Color.FromArgb (105, 255, 0),
		Color.FromArgb (97, 255, 0),
		Color.FromArgb (89, 255, 0),
		Color.FromArgb (82, 255, 0),
		Color.FromArgb (74, 255, 0),
		Color.FromArgb (66, 255, 0),
		Color.FromArgb (59, 255, 0),
		Color.FromArgb (51, 255, 0),
		Color.FromArgb (43, 255, 0),
		Color.FromArgb (36, 255, 0),
		Color.FromArgb (28, 255, 0),
		Color.FromArgb (20, 255, 0),
		Color.FromArgb (13, 255, 0),
		Color.FromArgb (5, 255, 0),
		Color.FromArgb (0, 255, 3),
		Color.FromArgb (0, 255, 10),
		Color.FromArgb (0, 255, 18),
		Color.FromArgb (0, 255, 25),
		Color.FromArgb (0, 255, 33),
		Color.FromArgb (0, 255, 41),
		Color.FromArgb (0, 255, 48),
		Color.FromArgb (0, 255, 56),
		Color.FromArgb (0, 255, 64),
		Color.FromArgb (0, 255, 71),
		Color.FromArgb (0, 255, 79),
		Color.FromArgb (0, 255, 87),
		Color.FromArgb (0, 255, 94),
		Color.FromArgb (0, 255, 102),
		Color.FromArgb (0, 255, 110),
		Color.FromArgb (0, 255, 117),
		Color.FromArgb (0, 255, 125),
		Color.FromArgb (0, 255, 133),
		Color.FromArgb (0, 255, 140),
		Color.FromArgb (0, 255, 148),
		Color.FromArgb (0, 255, 156),
		Color.FromArgb (0, 255, 163),
		Color.FromArgb (0, 255, 171),
		Color.FromArgb (0, 255, 178),
		Color.FromArgb (0, 255, 186),
		Color.FromArgb (0, 255, 194),
		Color.FromArgb (0, 255, 201),
		Color.FromArgb (0, 255, 209),
		Color.FromArgb (0, 255, 217),
		Color.FromArgb (0, 255, 224),
		Color.FromArgb (0, 255, 232),
		Color.FromArgb (0, 255, 240),
		Color.FromArgb (0, 255, 247),
		Color.FromArgb (0, 255, 255),
		Color.FromArgb (0, 247, 255),
		Color.FromArgb (0, 240, 255),
		Color.FromArgb (0, 232, 255),
		Color.FromArgb (0, 224, 255),
		Color.FromArgb (0, 217, 255),
		Color.FromArgb (0, 209, 255),
		Color.FromArgb (0, 201, 255),
		Color.FromArgb (0, 194, 255),
		Color.FromArgb (0, 186, 255),
		Color.FromArgb (0, 178, 255),
		Color.FromArgb (0, 171, 255),
		Color.FromArgb (0, 163, 255),
		Color.FromArgb (0, 156, 255),
		Color.FromArgb (0, 148, 255),
		Color.FromArgb (0, 140, 255),
		Color.FromArgb (0, 133, 255),
		Color.FromArgb (0, 125, 255),
		Color.FromArgb (0, 117, 255),
		Color.FromArgb (0, 110, 255),
		Color.FromArgb (0, 102, 255),
		Color.FromArgb (0, 94, 255),
		Color.FromArgb (0, 87, 255),
		Color.FromArgb (0, 79, 255),
		Color.FromArgb (0, 71, 255),
		Color.FromArgb (0, 64, 255),
		Color.FromArgb (0, 56, 255),
		Color.FromArgb (0, 48, 255),
		Color.FromArgb (0, 41, 255),
		Color.FromArgb (0, 33, 255),
		Color.FromArgb (0, 26, 255),
		Color.FromArgb (0, 18, 255),
		Color.FromArgb (0, 10, 255),
		Color.FromArgb (0, 3, 255),
		Color.FromArgb (5, 0, 255),
		Color.FromArgb (13, 0, 255),
		Color.FromArgb (20, 0, 255),
		Color.FromArgb (28, 0, 255),
		Color.FromArgb (36, 0, 255),
		Color.FromArgb (43, 0, 255),
		Color.FromArgb (51, 0, 255),
		Color.FromArgb (59, 0, 255),
		Color.FromArgb (66, 0, 255),
		Color.FromArgb (74, 0, 255),
		Color.FromArgb (82, 0, 255),
		Color.FromArgb (89, 0, 255),
		Color.FromArgb (97, 0, 255),
		Color.FromArgb (105, 0, 255),
		Color.FromArgb (112, 0, 255),
		Color.FromArgb (120, 0, 255),
		Color.FromArgb (128, 0, 255),
		Color.FromArgb (135, 0, 255),
		Color.FromArgb (143, 0, 255),
		Color.FromArgb (150, 0, 255),
		Color.FromArgb (158, 0, 255),
		Color.FromArgb (166, 0, 255),
		Color.FromArgb (173, 0, 255),
		Color.FromArgb (181, 0, 255),
		Color.FromArgb (189, 0, 255),
		Color.FromArgb (196, 0, 255),
		Color.FromArgb (204, 0, 255),
		Color.FromArgb (212, 0, 255),
		Color.FromArgb (219, 0, 255),
		Color.FromArgb (227, 0, 255),
		Color.FromArgb (235, 0, 255),
		Color.FromArgb (242, 0, 255),
		Color.FromArgb (250, 0, 255),
		Color.FromArgb (255, 0, 252),
		Color.FromArgb (255, 0, 245),
		Color.FromArgb (255, 0, 237),
		Color.FromArgb (255, 0, 229),
		Color.FromArgb (255, 0, 222),
		Color.FromArgb (255, 0, 214),
		Color.FromArgb (255, 0, 207),
		Color.FromArgb (255, 0, 199),
		Color.FromArgb (255, 0, 191),
		Color.FromArgb (255, 0, 184),
		Color.FromArgb (255, 0, 176),
		Color.FromArgb (255, 0, 168),
		Color.FromArgb (255, 0, 161),
		Color.FromArgb (255, 0, 153),
		Color.FromArgb (255, 0, 145),
		Color.FromArgb (255, 0, 138),
		Color.FromArgb (255, 0, 130),
		Color.FromArgb (255, 0, 122),
		Color.FromArgb (255, 0, 115),
		Color.FromArgb (255, 0, 107),
		Color.FromArgb (255, 0, 99),
		Color.FromArgb (255, 0, 92),
		Color.FromArgb (255, 0, 84),
		Color.FromArgb (255, 0, 77),
		Color.FromArgb (255, 0, 69),
		Color.FromArgb (255, 0, 61),
		Color.FromArgb (255, 0, 54),
		Color.FromArgb (255, 0, 46),
		Color.FromArgb (255, 0, 38),
		Color.FromArgb (255, 0, 31),
		Color.FromArgb (255, 0, 23),
		Color.FromArgb (255, 0, 15),
		Color.FromArgb (255, 0, 8)
	};
}
#endif
