using System;
using System.Threading;

class Demo
{
    public static void Main ()
    {
        // IntArray array = new IntArray (5000);
        IntArray array = new SynchronizedIntArray (5000);
        // IntArray array = new OptimizedSynchronizedIntArray (5000);
        // IntArray array = new CountingOptimizedSynchronizedIntArray (5000);

        ThreadStart handler = new ThreadStart (array.Sort);
        SorterManager manager = new SorterManager (handler, 4);

        int tick = Environment.TickCount;
        manager.BeginSort ();
        manager.EndSort ();
        int millis = Environment.TickCount - tick;

        array.VerifyArray ();
        array.PrintStatistics ();
        Console.WriteLine ("[{0} msecs]", millis);
    }
}

class SorterManager
{
    private Thread[] workers;

    public SorterManager (ThreadStart handler, int numThreads)
    {
        this.workers = new Thread[numThreads];
        for (int i = 0; i < this.workers.Length; i ++)
            this.workers[i] = new Thread (handler);
    }

    public void BeginSort ()
    {
        for (int i = 0; i < this.workers.Length; i ++)
            this.workers[i].Start ();
    }

    public void EndSort ()
    {
        for (int i = 0; i < this.workers.Length; i ++)
            this.workers[i].Join ();
    }
}