using System;
using System.IO;

class DirectoryViewer
{
    public static void View (String path)
    {
        DirectoryInfo di = new DirectoryInfo (path);
        if (! di.Exists)
        {
            // path doesn't refer to an existing directory
            return;
        }
        Console.WriteLine ("Directory of {0}:", di.FullName);

        // some file systems (e.g. NTFS) throw exceptions
        // when looking into directories without permission:
        // catch those exceptions and return
        FileInfo[] files = null;
        try 
        {
            // retrieve the names of all files in this directory
            files = di.GetFiles ();
        }
        catch (Exception)
        {
            return;
        }

        // print file names to console output
        for (int i = 0; i < files.Length; i ++)
        {
            Console.WriteLine ("  File {0}", files[i].Name);
        }
        Console.WriteLine ("{0} File(s)", files.Length);
        Console.WriteLine ();

        // retrieve the names of all directories in this directory
        DirectoryInfo[] dirs = di.GetDirectories ();
        for (int i = 0; i < dirs.Length; i ++)
            DirectoryViewer.View (dirs[i].FullName);
    }
}
