using System;
using System.IO;

class FileDump
{
    private String name;
    private FileStream fs;

    public FileDump (String name)
    {
        this.name = name;
    }

    public void OpenFile ()
    {
        this.fs = new FileStream (this.name, FileMode.Open);
    }

    public void DumpFile ()
    {
        byte[] bytes = new byte[16];
        for (int line = 0;; line += 16)
        {
            int count = this.fs.Read (bytes, 0, 16);
            this.DumpLine (bytes, count, line);
            if (count < 16)
                break;
        }
    }

    public void DumpLine (byte[] bytes, int count, int line)
    {
        Console.Write ("{0:X8}: ", line);

        // writing binary representation of byte
        for (int i = 0; i < count; i ++)
        {
            Console.Write ("{0:X2} ", bytes[i]);
            if ((i + 1) % 8 == 0)
                Console.Write (" ");
        }
        for (int i = count; i < 16; i ++)
        {
            Console.Write ("   ");
            if ((i + 1) % 8 == 0)
                Console.Write (" ");
        }
        Console.Write (" ");
        
        // writing readable representation of byte
        for (int i = 0; i < count; i ++)
        {
            char c = (bytes[i] >= ' ' && bytes[i] < '~') ?
                Convert.ToChar (bytes[i]) : '.';
            Console.Write ("{0}", c);
        }
        Console.WriteLine ();
    }

    public void CloseFile ()
    {
        this.fs.Close ();
    }
}

class Demo
{
    public static void Main ()
    {
        FileDump d = new FileDump ("..\\..\\FileDump.cs");
        d.OpenFile ();
        d.DumpFile ();
        d.CloseFile ();
    }
}