using System;
using System.Text;
using System.Threading;
using System.IO;
using System.Net;
using System.Net.Sockets;

class HighLevelEchoClient
{
    public static void Main ()
    {
        // define a network endpoint (IP address and port number)
        IPAddress adr = IPAddress.Loopback;
        IPEndPoint ep = new IPEndPoint (adr, 4711);

        // create a TcpClient
        TcpClient client = new TcpClient ();

        // connect client to a remote TCP host
        client.Connect (ep);

        // retrieve the NetworkStream used to send and receive data
        NetworkStream stream = client.GetStream ();

        // create comfortable string input and output objects
        StreamReader reader = new StreamReader (stream, Encoding.ASCII);
        StreamWriter writer = new StreamWriter (stream, Encoding.ASCII);

        // flush data to the underlying stream
        // after every call to StreamWriter.WriteLine
        writer.AutoFlush = true;

        while (true)
        {
            // send single line to server
            Console.Write ("Enter message: ");
            String line = Console.ReadLine ();
            writer.WriteLine (line);

            // check for end of conversation
            if (line.Trim ().ToLower ().Equals ("bye"))
                break;

            // read response from server
            String response = reader.ReadLine ();
            Console.WriteLine (response);
        }

        // close everything
        reader.Close ();
        writer.Close ();
        stream.Close ();
        client.Close ();
    }
}
