using System;
using System.Text;
using System.Net;
using System.Net.Sockets;

class LowLevelEchoClient
{
    public static void Main ()
    {
        LowLevelEchoClient client = new LowLevelEchoClient ();
        client.DoConversation ();
    }

    private void DoConversation ()
    {
        // initialize a new instance of the Socket class
        Socket socket = new Socket (
            AddressFamily.InterNetwork,
            SocketType.Stream,
            ProtocolType.Tcp
        );

        // define a network endpoint (IP address and port number)
        IPAddress adr = IPAddress.Loopback;
        IPEndPoint ep = new IPEndPoint (adr, 4711);

        // establish a connection to a (remote) host
        socket.Connect (ep);

        while (true)
        {
            // send single line to server
            Console.Write ("Enter message: ");
            String line = Console.ReadLine ();
            byte[] bytes = Encoding.ASCII.GetBytes (line + '\r');
            socket.Send (bytes);

            // check for end of conversation
            if (line.Trim ().ToLower ().Equals ("bye"))
                break;

            // read response from server
            byte[] response = new byte[256];
            socket.Receive (response);
            String s = Encoding.ASCII.GetString (response);

            // remove trailing '\0' chars
            int n = s.IndexOf ('\0');
            s = s.Substring (0, n);
            Console.WriteLine (s);
        }

        // disable sends and receives on this Socket
        socket.Shutdown (SocketShutdown.Both);

        // close Socket connection, release all associated resources
        socket.Close ();
    }
}