using System;
using System.Text;
using System.Net;
using System.Net.Sockets;

class LowLevelHelloWorldClient
{
    public static void Main ()
    {
        // initialize a new instance of the Socket class
        Socket s = new Socket (
            AddressFamily.InterNetwork,
            SocketType.Stream,
            ProtocolType.Tcp
        );

        // define a network endpoint (IP address and port number)
        IPAddress adr = IPAddress.Loopback;
        IPEndPoint ep = new IPEndPoint (adr, 4711);

        // establish a connection to a (remote) host
        s.Connect (ep);

        // retrieve message from server
        byte[] msg = new byte[1024];
        s.Receive (msg);

        // decode the specified byte array into a string
        String st = Encoding.ASCII.GetString (msg);
        st = st.Substring (0, st.IndexOf ('\0'));
        Console.WriteLine (st);

        // disable sends and receives on this Socket
        s.Shutdown (SocketShutdown.Both);

        // close Socket connection, release all associated resources
        s.Close ();
    }
}