using System;
using System.IO;
using System.Net.Sockets;

class SocketServer
{
    private void Run ()
    {
        // create a TcpListener listening on port 4711
        TcpListener tcpListener = new TcpListener (4711);
        tcpListener.Start ();

        bool finished = false;
        while (finished != true) 
        {
            // waiting for a client
            Console.WriteLine ("Server: Waiting for a client to connect ...");
            TcpClient client = tcpListener.AcceptTcpClient ();
            Console.WriteLine ("Server: Client is connected");

            // create a StreamReader and a StreamWriter object
            Stream st = client.GetStream ();
            StreamReader sr = new StreamReader (st);
            StreamWriter sw = new StreamWriter (st);

            // give client a "hello"
            sw.WriteLine ("Server: Enter BYE to exit ...\r");
            sw.Flush ();

            // wait for a message from the client and give him an echo
            bool done = false;
            while (! done) 
            {
                String request = sr.ReadLine ();
                if (request == null)
                    done = true;
                else 
                {
                    Console.WriteLine ("Server: sending \"{0}\"", request);
                    sw.WriteLine ("EchoServer responds: " + request + "\r");
                    sw.Flush ();
                    if (request.Trim ().ToUpper ().Equals ("BYE"))
                        done = true;
                    else if (request.Trim ().ToUpper ().Equals ("EXIT")) 
                    {
                        done = true;
                        finished = true;
                    }
                }
            }

            // close the streams and the connection
            sr.Close ();
            sw.Close ();
            client.Close ();
        }

        // clean up
        Console.WriteLine ("Server: closing ...");
        tcpListener.Stop ();
    }

    public static void Main ()
    {
        SocketServer app = new SocketServer ();
        app.Run ();
    }
}
